#!/usr/bin/env python2
#-*- coding:utf-8 -*-

# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html

#   Preview by fu_preview (modificed gimpfu) by Claude Lion [aka cli345] http://gimpchat.com/viewtopic.php?f=9&t=19420
#   & gimfu3 with tabs by J.F. Garcia [arakne]  https://www.arakne.es/en/gimp-plugin-follow-path-map-values-on-the-y-coordinate/
#	gegl_command by Kevin Payne & Claude Lion [cli345]: http://gimpchat.com/viewtopic.php?f=9&t=18040&start=30#p264354 
#   G'mic download: https://gmic.eu/download.html
#   Selection to Gradient Border by Tin Tran https://gimplearn.net/viewtopic.php?f=3&t=2739

#   468 Mandelbulber Gradients http://gimpchat.com/viewtopic.php?f=4&t=12737&
# ------------
#| Change Log |
# ------------
# Rel 0.1: Initial release. https://www.gimpscripts.net/2022/04/p-cosmos.html http://gimpchat.com/viewtopic.php?f=9&t=19849
# 
# Rel 0.2: more randomness for Planet type 'Alien'
#          add tab 'Strange': fractal Chirikov-Taylor,Flame,
# Flame big preview: https://www.gimpscripts.net/2020/11/flame-big-preview-win64bit.html
# Rel 0.3: in tab 'Strange': add 'Magnetar' (Incandescent) based on the PixLab tutorial: http://gimpchat.com/viewtopic.php?f=9&t=19849&sid=5a8984a6b18a9b50f8bfc8dc021e410c&start=30#p272583
#		   add 'Magnetar' by color
#		   add 'Fractal-explorer' (interactive)
#		   add options 'Spiralize'
#          use 'Selection to Gradient Border' - Ver.1 
#          add type Planet: 'Random Plasma', 'Dirty'
#          add 'Fragment Blur' in tab Ring
# Rel 0.4: bug fix
#          add Light Rays and Quasar.
# Rel 0.5: add type Planet: 'Wrinkled', 'Cratered'
#          preview is disabled by default after running the plug-in
# Rel 0.6: add tab: UFO (Ship)
#          + adding a space before the name of existing layers
# Rel 0.7: add Invert Long Shadow
#          add new type UFO: 'Flying Saucer 2','Arrowhead'
# Rel 0.8: add opacity to Invert Long Shadow
#          add Fractalship
# Rel 0.9: add tab FX
# Rel 1.0: add to tab FX: Meteorize
#		   add to Tab Strange: Turbulence  
#          add to Tab Atmosphere: Lightning
#          add to Tab Ring: Stargate from Ring
#          add to Tab UFO: Add Color
#		   add file .po and .mo to translate (lokalize in: ... \plug-ins\locale\...
#													   if: ... \plug-ins\P&M Cosmos.py )
# Rel 1.1: add mask to Shadow Ring
#		   add size to Spaceship
#		   add Drop Water to Planet
#          added a German translation by Nelo
# Rel 1.2: add new SpaceShip: Elipsoid
#		   add new tab: FX-3D
#		   add Zoom Motion to Gmic Stars
# Rel 1.3: add '3D Block' and 'Random deform' to tab: FX-3D
# Rel 1.4: bug fix for 3D Block (this filter GMIC resize image to square)
#          more stars control based on pm_create_stars_in_the_night.py http://gimpchat.com/viewtopic.php?f=9&t=19915
# Rel 1.5: remove the green color of the stars
#		   add gradmap or/and alien_map to '3D Extrude'
# Rel 1.6: renamed the "UFO" tab to 'Ships'
#          add Famous Ships to tab 'Ships' (based on the font famous_ships.ttf, famousspaceships2.ttf, starnavy.ttf by Daniel Zadorozny http://www.iconian.com/)
# Rel 1.7: add 'surface' to Famous Ships (by G'MIC Super-Pixels)
#		   extracting the "Emboss" option in the "Ships" tab as any choice
#          remove white pixels from the edges of Famous Ships
# Rel 1.8: add Motion Stargate to tab 'Ring'
#          add Star Burst to tab 'Stars' based on pm_create_stars_burst.py by Pocholo http://gimpchat.com/viewtopic.php?f=9&t=19849&start=100#p273256
#          add new type Planet: Cloudy (with active gradient)
# Rel 1.9: add new type 'surface': Ministeck, "Truchet (straight or curved)","Grid Triangular"
# Rel 2.0: added options: - for Ring added option "Remove black color from Ring",
#                         - for Ship new surface: "Pills","Box Fitting","Active Pattern (scaled)", bugfix for Ministeck,
#                         - added 21 Patterns SpaceShip,
#                         - for FX-3D new option "Crease",
#                         - for Comet Planet added option Tail angle & Opacity
# Rel 2.1: bugfix for tab "Atmosphere",added 'opacity' to 'Luminace'
#          add type Planet: "Camouflage"
        
#####################################################################################################################################################
############################################# START fu_preview 0.1.1 by Claude Lion $ J.F. Garcia ###################################################
#####################################################################################################################################################

import string as _string
import math
import gimp
import gimpcolor
import colorsys
import re
from gimpenums import *
pdb = gimp.pdb
import os, time, sys
import gettext
#t = gettext.translation("gimp20-python", gimp.locale_directory, fallback=True)	MrQ for translate in dir "locle"
#_ = t.ugettext																	MrQ for translate in dir "locle"
import random
class error(RuntimeError): pass
class CancelError(RuntimeError): pass

PF_INT8        = PDB_INT8
PF_INT16       = PDB_INT16
PF_INT32       = PDB_INT32
PF_INT         = PF_INT32
PF_FLOAT       = PDB_FLOAT
PF_STRING      = PDB_STRING
PF_VALUE       = PF_STRING
PF_COLOR       = PDB_COLOR
PF_COLOUR      = PF_COLOR
PF_ITEM        = PDB_ITEM
PF_DISPLAY     = PDB_DISPLAY
PF_IMAGE       = PDB_IMAGE
PF_LAYER       = PDB_LAYER
PF_CHANNEL     = PDB_CHANNEL
PF_DRAWABLE    = PDB_DRAWABLE
PF_VECTORS     = PDB_VECTORS

PF_TOGGLE      = 1000
PF_BOOL        = PF_TOGGLE
PF_SLIDER      = 1001
PF_SPINNER     = 1002
PF_ADJUSTMENT  = PF_SPINNER

PF_FONT        = 1003
PF_FILE        = 1004
PF_BRUSH       = 1005
PF_PATTERN     = 1006
PF_GRADIENT    = 1007
PF_RADIO       = 1008
PF_TEXT        = 1009
PF_PALETTE     = 1010
PF_FILENAME    = 1011
PF_DIRNAME     = 1012
PF_OPTION      = 1013
PF_TAB         = 1014
PF_DRAW        = 1015
PF_TITLE       = 1016

_type_mapping = {
    PF_INT8        : PDB_INT8,
    PF_INT16       : PDB_INT16,
    PF_INT32       : PDB_INT32,
    PF_FLOAT       : PDB_FLOAT,
    PF_STRING      : PDB_STRING,
    PF_COLOR       : PDB_COLOR,
    PF_ITEM        : PDB_ITEM,
    PF_DISPLAY     : PDB_DISPLAY,
    PF_IMAGE       : PDB_IMAGE,
    PF_LAYER       : PDB_LAYER,
    PF_CHANNEL     : PDB_CHANNEL,
    PF_DRAWABLE    : PDB_DRAWABLE,
    PF_VECTORS     : PDB_VECTORS,

    PF_TOGGLE      : PDB_INT32,
    PF_SLIDER      : PDB_FLOAT,
    PF_SPINNER     : PDB_INT32,

    PF_FONT        : PDB_STRING,
    PF_FILE        : PDB_STRING,
    PF_BRUSH       : PDB_STRING,
    PF_PATTERN     : PDB_STRING,
    PF_GRADIENT    : PDB_STRING,
    PF_RADIO       : PDB_STRING,
    PF_TEXT        : PDB_STRING,
    PF_PALETTE     : PDB_STRING,
    PF_FILENAME    : PDB_STRING,
    PF_DIRNAME     : PDB_STRING,
    PF_OPTION      : PDB_INT32,
    PF_TAB         : PDB_STRING,
    PF_DRAW        : PDB_INT32,
    PF_TITLE       : PDB_STRING,
}

_obj_mapping = {
    PF_INT8        : int,
    PF_INT16       : int,
    PF_INT32       : int,
    PF_FLOAT       : float,
    PF_STRING      : str,
    PF_COLOR       : gimpcolor.RGB,
    PF_ITEM        : int,
    PF_DISPLAY     : gimp.Display,
    PF_IMAGE       : gimp.Image,
    PF_LAYER       : gimp.Layer,
    PF_CHANNEL     : gimp.Channel,
    PF_DRAWABLE    : gimp.Drawable,
    PF_VECTORS     : gimp.Vectors,

    PF_TOGGLE      : bool,
    PF_SLIDER      : float,
    PF_SPINNER     : int,

    PF_FONT        : str,
    PF_FILE        : str,
    PF_BRUSH       : str,
    PF_PATTERN     : str,
    PF_GRADIENT    : str,
    PF_RADIO       : str,
    PF_TEXT        : str,
    PF_PALETTE     : str,
    PF_FILENAME    : str,
    PF_DIRNAME     : str,
    PF_OPTION      : int,
    PF_TAB         : str,
    PF_DRAW        : int,
    PF_TITLE       : str,
}

_registered_plugins_ = {}


def register(proc_name, blurb, help, author, copyright, date, label,
             imagetypes, params, results, function,
             menu=None, domain=None, on_query=None, on_run=None):
    """This is called to register a new plug-in."""

    # First perform some sanity checks on the data
    def letterCheck(str):
        allowed = _string.letters + _string.digits + "_" + "-"
        for ch in str:
            if not ch in allowed:
                return 0
        else:
            return 1

    if not letterCheck(proc_name):
        raise error, "procedure name contains illegal characters"

    for ent in params:
        if len(ent) < 4:
            raise error, ("parameter definition must contain at least 4 "
                          "elements (%s given: %s)" % (len(ent), ent))

        if type(ent[0]) != int:
            raise error, "parameter types must be integers"

        if not letterCheck(ent[1]):
            raise error, "parameter name contains illegal characters"

    for ent in results:
        if len(ent) < 3:
            raise error, ("result definition must contain at least 3 elements "
                          "(%s given: %s)" % (len(ent), ent))

        if type(ent[0]) != type(42):
            raise error, "result types must be integers"

        if not letterCheck(ent[1]):
            raise error, "result name contains illegal characters"

    plugin_type = PLUGIN

    if (not proc_name.startswith("python-") and
        not proc_name.startswith("python_") and
        not proc_name.startswith("extension-") and
        not proc_name.startswith("extension_") and
        not proc_name.startswith("plug-in-") and
        not proc_name.startswith("plug_in_") and
        not proc_name.startswith("file-") and
        not proc_name.startswith("file_")):
           proc_name = "python-fu-" + proc_name

    # if menu is not given, derive it from label
    need_compat_params = False
    if menu is None and label:
        fields = label.split("/")
        if fields:
            label = fields.pop()
            menu = "/".join(fields)
            need_compat_params = True

            import warnings
            message = ("%s: passing the full menu path for the menu label is "
                       "deprecated, use the 'menu' parameter instead"
                       % (proc_name))
            warnings.warn(message, DeprecationWarning, 3)

        if need_compat_params and plugin_type == PLUGIN:
            file_params = [(PDB_STRING, "filename", "The name of the file", ""),
                           (PDB_STRING, "raw-filename", "The name of the file", "")]

            if menu is None:
                pass
            elif menu.startswith("<Load>"):
                params[0:0] = file_params
            elif menu.startswith("<Image>") or menu.startswith("<Save>"):
                params.insert(0, (PDB_IMAGE, "image", "Input image", None))
                params.insert(1, (PDB_DRAWABLE, "drawable", "Input drawable", None))
                if menu.startswith("<Save>"):
                    params[2:2] = file_params

    _registered_plugins_[proc_name] = (blurb, help, author, copyright,
                                       date, label, imagetypes,
                                       plugin_type, params, results,
                                       function, menu, domain,
                                       on_query, on_run)

def _query():
    for plugin in _registered_plugins_.keys():
        (blurb, help, author, copyright, date,
         label, imagetypes, plugin_type,
         params, results, function, menu, domain,
         on_query, on_run) = _registered_plugins_[plugin]

        def make_params(params):
            return [(_type_mapping[x[0]],
                     x[1],
                     _string.replace(x[2], "_", "")) for x in params]

        params = make_params(params)
        # add the run mode argument ...
        params.insert(0, (PDB_INT32, "run-mode",
                                     "The run mode { RUN-INTERACTIVE (0), RUN-NONINTERACTIVE (1) }"))

        results = make_params(results)

        if domain:
            try:
                (domain, locale_dir) = domain
                gimp.domain_register(domain, locale_dir)
            except ValueError:
                gimp.domain_register(domain)

        gimp.install_procedure(plugin, blurb, help, author, copyright,
                               date, label, imagetypes, plugin_type,
                               params, results)

        if menu:
            gimp.menu_register(plugin, menu)
        if on_query:
            on_query()

def getXtra(xtra, valName, defValue):
    p = defValue
    if xtra.get(valName):
        p = xtra.get(valName)
    return p

def _get_defaults(proc_name):
    import gimpshelf

    (blurb, help, author, copyright, date,
     label, imagetypes, plugin_type,
     params, results, function, menu, domain,
     on_query, on_run) = _registered_plugins_[proc_name]

    key = "python-fu-save--" + proc_name

    if gimpshelf.shelf.has_key(key):
        return gimpshelf.shelf[key]
    else:
        # return the default values
        return [x[3] for x in params]

def _set_defaults(proc_name, defaults):
    import gimpshelf

    key = "python-fu-save--" + proc_name
    gimpshelf.shelf[key] = defaults

def _interact(proc_name, start_params):
    (blurb, help, author, copyright, date, label, imagetypes, plugin_type, params, results, function, menu, domain, on_query, on_run) = _registered_plugins_[proc_name]

    def run_script(run_params):
        params = start_params + tuple(run_params)
        _set_defaults(proc_name, params)
        return apply(function, params)

    params = params[len(start_params):]

    # short circuit for no parameters ...
    if len(params) == 0:
         return run_script([])

    import pygtk
    pygtk.require('2.0')

    import gimpui, gtk
#    import pango
    gimpui.gimp_ui_init () # add MrQ
    defaults = _get_defaults(proc_name)
    defaults = defaults[len(start_params):]

    class EntryValueError(Exception):
        pass

    def warning_dialog(parent, primary, secondary=None):
        dlg = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE, primary)
        if secondary:
            dlg.format_secondary_text(secondary)
        dlg.run()
        dlg.destroy()

    def error_dialog(parent, proc_name):
        import sys, traceback

        exc_str = exc_only_str = _("Missing exception information")
        try:
            etype, value, tb = sys.exc_info()
            exc_str = "".join(traceback.format_exception(etype, value, tb))
            exc_only_str = "".join(traceback.format_exception_only(etype, value))
        finally:
            etype = value = tb = None

        title = _("An error occurred running %s") % proc_name
        dlg = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, title)
        dlg.format_secondary_text(exc_only_str)

        alignment = gtk.Alignment(0.0, 0.0, 1.0, 1.0)
        alignment.set_padding(0, 0, 12, 12)
        dlg.vbox.pack_start(alignment)
        alignment.show()

        expander = gtk.Expander(_("_More Information"));
        expander.set_use_underline(True)
        expander.set_spacing(6)
        alignment.add(expander)
        expander.show()

        scrolled = gtk.ScrolledWindow()
        scrolled.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        scrolled.set_size_request(-1, 200)
        expander.add(scrolled)
        scrolled.show()

        label = gtk.Label(exc_str)
        label.set_alignment(0.0, 0.0)
        label.set_padding(6, 6)
        label.set_selectable(True)
        scrolled.add_with_viewport(label)
        label.show()

        def response(widget, id):
            widget.destroy()

        dlg.connect("response", response)
        dlg.set_resizable(True)
        dlg.show()

    # define a mapping of param types to edit objects ...
    class StringEntry(gtk.Entry):
        def __init__(self, default="", **kwargs): # modif C.L.
            gtk.Entry.__init__(self)
            self.set_text(str(default))
            self.set_activates_default(True)
            #~ self.connect('paste-clipboard', lambda _: kwargs['dialg'].la_previ.invalidate()) # modif C.L.
            self.get_buffer().connect('inserted-text', lambda _1, _2, _3, _4: kwargs['dialg'].la_previ.invalidate()) # modif C.L.
            self.get_buffer().connect('deleted-text', lambda _1, _2, _3: kwargs['dialg'].la_previ.invalidate()) # modif C.L

        def get_value(self):
            return self.get_text()


    class LabelTitle(gtk.Label):
        #def __init__ (self, default="", **kwargs): # modif C.L. ???
        def __init__(self, default="", align = (0.0, 0.0)):		
            gtk.Label.__init__(self)
            self.set_label(str(default))
            self.set_use_markup(True)
            if align != None:
                self.set_alignment(align[0],align[1])
        def get_value(self):
            return self.get_label()

    class TextEntry(gtk.ScrolledWindow):
        def __init__ (self, default="", **kwargs): # modif C.L.
            gtk.ScrolledWindow.__init__(self)
            self.set_shadow_type(gtk.SHADOW_IN)

            self.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
            self.set_size_request(100, -1)

            self.view = gtk.TextView()
            self.add(self.view)
            self.view.show()
            self.buffer = self.view.get_buffer()
            self.set_value(str(default))
            self.buffer.connect('changed', lambda _: kwargs['dialg'].la_previ.invalidate()) # modif C.L.			

        def set_value(self, text):
            self.buffer.set_text(text)

        def get_value(self):
            return self.buffer.get_text(self.buffer.get_start_iter(), self.buffer.get_end_iter())

    class IntEntry(StringEntry):
        def get_value(self):
            try:
                return int(self.get_text())
            except ValueError, e:
                raise EntryValueError, e.args

    class FloatEntry(StringEntry):
            def get_value(self):
                try:
                    return float(self.get_text())
                except ValueError, e:
                    raise EntryValueError, e.args

    def precision(step):
        # calculate a reasonable precision from a given step size
        if math.fabs(step) >= 1.0 or step == 0.0:
            digits = 0
        else:
            digits = abs(math.floor(math.log10(math.fabs(step))));
        if digits > 20:
            digits = 20
        return int(digits)

    class SliderEntry(gtk.HScale):
        # bounds is (upper, lower, step)
        def __init__(self, default=0, bounds=(0, 100, 5), **kwargs): # modif C.L.
            step = bounds[2]
            self.adj = gtk.Adjustment(default, bounds[0], bounds[1],
                                      step, 10 * step, 0)
            # modif C.L.
            def react(adj):
                return self.get_toplevel().la_previ.invalidate()
            #~ self.adj.connect('value-changed', lambda adj: self.get_toplevel().la_previ.invalidate())
            self.adj.connect('value-changed', react)
            # end modif C.L.
            gtk.HScale.__init__(self, self.adj)
            self.set_digits(precision(step))

        def get_value(self):
            return self.adj.value

    class SpinnerEntry(gtk.SpinButton):
        # bounds is (upper, lower, step)
        def __init__(self, default=10, bounds=(0, 100, 5), **kwargs): # modif C.L.
            step = bounds[2]
            self.adj = gtk.Adjustment(default, bounds[0], bounds[1],
                                      step, 10 * step, 0)
            self.adj.connect('value-changed', lambda adj: kwargs['dialg'].la_previ.invalidate()) # modif C.L.
            gtk.SpinButton.__init__(self, self.adj, step, precision(step))


    class ToggleEntry(gtk.ToggleButton):
        #~ def __init__(self, default=0):
        def __init__(self, default=0,labels=[_("DON'T USE"),_("YES")], **kwargs): # modif C.L.
            
            gtk.ToggleButton.__init__(self)
            self.labels = labels
            self.label = gtk.Label(labels[0])
            self.add(self.label)
            self.label.show()

            #~ self.connect("toggled", self.changed)
            # modif C.L.
            def react(tog):
                self.changed(tog)
                return kwargs['dialg'].la_previ.invalidate()
            self.connect("toggled", react)
            # end modif C.L.


            self.set_active(default)

        def changed(self, tog):
            if tog.get_active():
                self.label.set_text(self.labels[1])
            else:
                self.label.set_text(self.labels[0])

        def get_value(self):
            return self.get_active()

    class RadioEntry(gtk.VBox):
        def __init__(self, default=0, items=((_("YES"), 1), (_("No"), 0)), **kwargs): # modif C.L.
            gtk.VBox.__init__(self, homogeneous=False, spacing=2)

            button = None

            for (label, value) in items:
                button = gtk.RadioButton(button, label)
                self.pack_start(button)
                button.show()

                button.connect("toggled", self.changed, value)

                if value == default:
                    button.set_active(True)
                    self.active_value = value

        def changed(self, radio, value):
            if radio.get_active():
                self.active_value = value

        def get_value(self):
            return self.active_value

    class ComboEntry(gtk.ComboBox):
        def __init__(self, default=0, items=(), **kwargs): # modif C.L.
            store = gtk.ListStore(str)
            for item in items:
                store.append([item])

            gtk.ComboBox.__init__(self, model=store)

            cell = gtk.CellRendererText()
            self.pack_start(cell)
            self.set_attributes(cell, text=0)

            self.set_active(default)
            self.connect('changed', lambda adj: kwargs['dialg'].la_previ.invalidate()) # modif C.L.

        def get_value(self):
            return self.get_active()

    def FileSelector(default="", title=None, **kwargs): # modif C.L.
        # FIXME: should this be os.path.separator?  If not, perhaps explain why?
        if default and default.endswith("/"):
            if default == "/": default = ""
            return DirnameSelector(default)
        else:
            return FilenameSelector(default, title=title, save_mode=False)

    class FilenameSelector(gtk.HBox):
        #gimpfu.FileChooserButton
        def __init__(self, default, save_mode=True, title=None, **kwargs): # modif C.L.
            super(FilenameSelector, self).__init__()
            if not title:
                self.title = _("Python-Fu File Selection")
            else:
                self.title = title
            self.save_mode = save_mode
            box = self
            self.entry = gtk.Entry()
            image = gtk.Image()
            image.set_from_stock(gtk.STOCK_FILE, gtk.ICON_SIZE_BUTTON)
            self.button = gtk.Button()
            self.button.set_image(image)
            box.pack_start(self.entry)
            box.pack_start(self.button, expand=False)
            self.button.connect("clicked", self.pick_file)
            if default:
                self.entry.set_text(default)

        def show(self):
            super(FilenameSelector, self).show()
            self.button.show()
            self.entry.show()

        def pick_file(self, widget):
            entry = self.entry
            dialog = gtk.FileChooserDialog(
                         title=self.title,
                         action=(gtk.FILE_CHOOSER_ACTION_SAVE
                                     if self.save_mode else
                                 gtk.FILE_CHOOSER_ACTION_OPEN),
                         buttons=(gtk.STOCK_CANCEL,
                                gtk.RESPONSE_CANCEL,
                                gtk.STOCK_SAVE
                                     if self.save_mode else
                                gtk.STOCK_OPEN,
                                gtk.RESPONSE_OK)
                        )
            dialog.set_alternative_button_order ((gtk.RESPONSE_OK, gtk.RESPONSE_CANCEL))
            dialog.show_all()
            response = dialog.run()
            if response == gtk.RESPONSE_OK:
                entry.set_text(dialog.get_filename())
            dialog.destroy()

        def get_value(self):
            return self.entry.get_text()


    class DirnameSelector(gtk.FileChooserButton):
        def __init__(self, default="", **kwargs): # modif C.L.
            gtk.FileChooserButton.__init__(self,
                                           _("Python-Fu Folder Selection"))
            self.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
            if default:
                self.set_filename(default)

        def get_value(self):
            return self.get_filename()

    # modif C.L.
    class ColorSelector(gimpui.ColorSelector):
        def __init__(self, default=gimpcolor.RGB(1.0, 0, 0), **kwargs):
            ret = gimpui.ColorSelector.__init__(self, default)
            self.connect('color-changed', lambda _: kwargs['dialg'].la_previ.invalidate())
            return ret
    class FontSelector(gimpui.FontSelector):
        def __init__(self, default="Sans", **kwargs):
            ret = gimpui.FontSelector.__init__(self, default)
            self.connect('font-set', lambda _1, _2, _3: kwargs['dialg'].la_previ.invalidate())
            return ret
    class PatternSelector(gimpui.PatternSelector):
        def __init__(self, default="", **kwargs):
            ret = gimpui.PatternSelector.__init__(self, default)
            self.connect('pattern-set', lambda *_: kwargs['dialg'].la_previ.invalidate())
            return ret
    class GradientSelector(gimpui.GradientSelector):
        def __init__(self, default="", **kwargs):
            ret = gimpui.GradientSelector.__init__(self, default)
            self.connect('gradient-set', lambda *_: kwargs['dialg'].la_previ.invalidate())
            return ret
    class PaletteSelector(gimpui.PaletteSelector):
        def __init__(self, default="", **kwargs):
            ret = gimpui.PaletteSelector.__init__(self, default)
            self.connect('palette-set', lambda *_: kwargs['dialg'].la_previ.invalidate())
            return ret
    # end modif C.L.
    class DrawCanvas(gtk.DrawingArea):
        def __init__(self,default, size=(100,100)):
            gtk.DrawingArea.__init__(self)
            self.set_size_request(size[0],size[1])
        def get_value(self):
            return 0

    _edit_mapping = {
            PF_INT8        : IntEntry,
            PF_INT16       : IntEntry,
            PF_INT32       : IntEntry,
            PF_FLOAT       : FloatEntry,
            PF_STRING      : StringEntry,
            PF_COLOR       : ColorSelector, # modif C.L.
            PF_ITEM        : IntEntry,  # should handle differently ...
            PF_IMAGE       : gimpui.ImageSelector,
            PF_LAYER       : gimpui.LayerSelector,
            PF_CHANNEL     : gimpui.ChannelSelector,
            PF_DRAWABLE    : gimpui.DrawableSelector,
            PF_VECTORS     : gimpui.VectorsSelector,

            PF_TOGGLE      : ToggleEntry,
            PF_SLIDER      : SliderEntry,
            PF_SPINNER     : SpinnerEntry,
            PF_RADIO       : RadioEntry,
            PF_OPTION      : ComboEntry,

            PF_FONT        : FontSelector,
            PF_FILE        : FileSelector,
            PF_FILENAME    : FilenameSelector,
            PF_DIRNAME     : DirnameSelector,
            PF_BRUSH       : gimpui.BrushSelector,
            PF_PATTERN     : PatternSelector,  # modif C.L.
            PF_GRADIENT    : GradientSelector, # modif C.L.
            PF_PALETTE     : PaletteSelector,  # modif C.L.
            PF_TEXT        : TextEntry,
            PF_TAB         : TextEntry,
            PF_DRAW        : DrawCanvas,
            PF_TITLE       : LabelTitle,
    }
    # JFGARCIA - modified: to pass args to the on_run
    if on_run:
        on_run(start_params+tuple(params))

    dialog = gimpui.Dialog(proc_name, "python-fu", None, 0, None, proc_name, (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OK, gtk.RESPONSE_OK))

    dialog.set_alternative_button_order((gtk.RESPONSE_OK, gtk.RESPONSE_CANCEL))

    dialog.set_transient()

    # modif C.L.
    hboxPrincipal = gtk.HBox(spacing=10)
	
    #dialog.vbox.pack_start(hboxPrincipal)			        # modif MrQ
    swin = gtk.ScrolledWindow()                             # New line MrQ
    swin.add_with_viewport(hboxPrincipal)                   # New Line MrQ
    dialog.vbox.pack_start(swin)                            # New Line MrQ
    swin.show()                                             # New Line MrQ	

    hboxPrincipal.show()
    
    dialog.la_previ = gimpui.DrawablePreview(start_params[1])
    dialog.la_previ.set_update(False)						# disable Preview
    dialog.la_previ.set_size_request(504,500)               # New Line MrQ	
    dialog.la_previ.la_img = start_params[0]
    dialog.la_previ.la_layer = start_params[1]
    hboxPrincipal.pack_start(dialog.la_previ)

    dialog.set_default_size(1100, 650)  					# New Line MrQ
    dialog.la_previ.show()
    # end modif C.L.

    vbox = gtk.VBox(False, 2)
    vbox.set_border_width(2)
    #vbox.set_size_request(-10, 0)                           # modif C.L. + MrQ
    #~ dialog.vbox.pack_start(vbox)
    hboxPrincipal.pack_start(vbox) # modif C.L.
    vbox.show()

    if blurb:
        if domain:
            try:
                (domain, locale_dir) = domain
                trans = gettext.translation(domain, locale_dir, fallback=True)
            except ValueError:
                trans = gettext.translation(domain, fallback=True)
            blurb = trans.ugettext(blurb)
        box = gimpui.HintBox(blurb)
        vbox.pack_start(box, expand=False)
        box.show()

    table = gtk.Table(1, 2, False)
    table.set_row_spacings(2)
    table.set_col_spacings(2)
    vbox.pack_start(table, expand=True)
    table.show()

    notebook = gtk.Notebook()
    tables=[]
    for i in range(len(params)):
        if params[i][0]==PF_TAB:
            vals = params[i][4]
            currPage = params[i][3]

            for n in vals:
                tbl = gtk.Table(2, 2, False)
                tbl.set_row_spacings(5)
                tbl.set_col_spacings(5)
                tbl.show()
                tables.append({'table':tbl,'rows':0, 'totCols':0})
                notebook.append_page(tbl, gtk.Label(n))
                notebook.set_current_page(currPage)

    if len(tables)>0:
        table.attach(notebook, 0,6,0,1)
        notebook.show()
    else:
        tables.append({'table':table,'rows':0})
    # modif C.L.
    def ifinvalidated(p_la_previ):
        
        # get dimension
        #===============
        x, y = p_la_previ.get_position()
        w, h = p_la_previ.get_size()
        
        # Effet
        #=========
        # has alpha
        lb_alpha = pdb.gimp_drawable_has_alpha(p_la_previ.la_layer)
        
        # img, layer temporaires
        tempImg = pdb.gimp_image_new(w, h, 0)
        #~ tempLayer = pdb.gimp_layer_new(tempImg, w, h, 0, 'temp', 100, 0)
        tempLayer = pdb.gimp_layer_new(tempImg, w, h, lb_alpha, 'temp', 100, 0)
        pdb.gimp_image_insert_layer(tempImg, tempLayer, None, 0)
        
        # copie orig dans tempo
        rgnPreviIn = p_la_previ.la_layer.get_pixel_rgn(x, y, w, h)
        rgnTemp = tempLayer.get_pixel_rgn(0, 0, w, h)
        rgnTemp[0:w, 0:h] = rgnPreviIn[x:x+w, y:y+h]
        
        # effect
        tempImg.undo_group_start()
        tempImg.disable_undo()
        
        params = []

        try:
            for wid in edit_wids:
                params.append(wid.get_value())
        except EntryValueError:
            warning_dialog(dialog, _("Invalid input for '%s'") % wid.desc)
        else:
            try:
                paramsTot = (tempImg, tempLayer) + tuple(params)
                _set_defaults(proc_name, start_params + tuple(params))
                function(*paramsTot)
                
                res = tempImg.active_layer
                
                if not lb_alpha: pdb.gimp_layer_flatten(res)
                
                tempImg.undo_group_end()
                
                rgnRes = res.get_pixel_rgn(0, 0, w, h)
                
                # mise dans previ
                #================
                p_la_previ.draw_buffer(rgnRes[0:w, 0:h], int(3+lb_alpha)*w)
                
                pdb.gimp_image_delete(tempImg)
                
                #pdb.gimp_display_new(tempImg)
            except CancelError:
                pass
            except Exception as e:
                dialog.set_response_sensitive(gtk.RESPONSE_CANCEL, True)
                error_dialog(dialog, proc_name)
                raise
    # end modif C.L.
    def response(dlg, id):
        if id == gtk.RESPONSE_OK:
            dlg.set_response_sensitive(gtk.RESPONSE_OK, False)
            dlg.set_response_sensitive(gtk.RESPONSE_CANCEL, False)
            params = []
            try:
                for wid in edit_wids:
                    params.append(wid.get_value())
            except EntryValueError:
                warning_dialog(dialog, _("Invalid input for '%s'") % wid.desc)
            else:
                try:
                    dialog.res = run_script(params)
                except Exception:
                    dlg.set_response_sensitive(gtk.RESPONSE_CANCEL, True)
                    error_dialog(dialog, proc_name)
                    raise
        dialog.la_previ.set_update(False)	# disable Preview
        gtk.main_quit()
    dialog.la_previ.connect('invalidated', ifinvalidated) # modif C.L.
    dialog.connect("response", response)
    iniX=0
    row=0
    edit_wids = []

    for i in range(len(params)):
        paramsi = params[i]
        pf_type = paramsi[0]
        name, desc = (paramsi[1], paramsi[2])
        def_val = defaults[i]

        tab, incr, rows, connect, cols = (0, 1, 1, None, 1)
        if len(params[i])>5:
            xtra = params[i][5]
            incr = int(getXtra(xtra, 'newLine', 1))
            if incr==0 : cols = 1
            cols = getXtra(xtra, 'cols'   , cols)
            iniX = getXtra(xtra, 'iniCol' , iniX)
            rows = getXtra(xtra, 'rows'   , 1)
            tab  = getXtra(xtra, 'tab'    , 0)
            connect = getXtra(xtra,'connect', None)
        else:
            iniX = 0
        tbl = tables[tab]['table']
        row = tables[tab]['rows']


        if pf_type==PF_TAB:
            wid = _edit_mapping[pf_type](None)
        else:
            if pf_type != PF_TITLE:
                label = gtk.Label(desc)
                label.set_use_underline(True)
                label.set_alignment(0.0, 0.5)
                tbl.attach(label, iniX + 1, iniX + 2, row, row + rows, xoptions = gtk.FILL)
                label.show()

            if pf_type in (PF_SPINNER, PF_SLIDER, PF_RADIO, PF_OPTION, PF_DRAW):
                wid = _edit_mapping[pf_type](def_val, params[i][4], dialg=dialog) # modif C.L.
            elif pf_type==PF_TOGGLE:
                if isinstance(paramsi[4], list):
                    wid = _edit_mapping[pf_type](def_val, paramsi[4],dialg=dialog)
                else:
                    wid = _edit_mapping[pf_type](def_val)				


            elif pf_type==PF_TITLE:
                wid = _edit_mapping[pf_type](desc)
            else:
                wid = _edit_mapping[pf_type](def_val, dialg=dialog) # modif C.L.
            if pf_type!=PF_TITLE:
                label.set_mnemonic_widget(wid)
                tbl.attach(wid, iniX + 2, iniX + 2 + cols, row, row + rows, yoptions=0)
                iniX = iniX + cols + 1
            else:
                tbl.attach(wid, iniX, iniX+cols, row, row + rows, xoptions=gtk.FILL)
            # jfGarcia: strip html tags from toolTip
            tTip = re.sub('<[^<]+?>', '', desc)
            if pf_type != PF_TEXT:
                wid.set_tooltip_text(tTip)
            else:
                # Attach tip to TextView, not to ScrolledWindow
                wid.view.set_tooltip_text(tTip)

            wid.set_name(name)
            if connect:
                try:
                    wid.connect(connect['signal'],connect['function'])
                except Exception, e:
                    pass
            wid.show()
            wid.desc = desc

        edit_wids.append(wid)

        tables[tab]['rows'] += incr
        if incr==1:
           iniX=0

    progress_vbox = gtk.VBox(False, 6)
    vbox.pack_end(progress_vbox, expand=False)
    progress_vbox.show()

    progress = gimpui.ProgressBar()
    progress_vbox.pack_start(progress)
    progress.show()
	
    dialog.show()

    gtk.main()

    if hasattr(dialog, "res"):
        res = dialog.res
        dialog.destroy()
        return res
    else:
        dialog.destroy()
        raise CancelError

def _run(proc_name, params):
    run_mode = params[0]
    func = _registered_plugins_[proc_name][10]

    if run_mode == RUN_NONINTERACTIVE:
        return apply(func, params[1:])

    script_params = _registered_plugins_[proc_name][8]

    min_args = 0
    if len(params) > 1:
        for i in range(1, len(params)):
            param_type = _obj_mapping[script_params[i - 1][0]]
            if not isinstance(params[i], param_type):
                break

        min_args = i

    if len(script_params) > min_args:
        start_params = params[:min_args + 1]

        if run_mode == RUN_WITH_LAST_VALS:
            default_params = _get_defaults(proc_name)
            params = start_params + default_params[min_args:]
        else:
            params = start_params
    else:
       run_mode = RUN_NONINTERACTIVE

    if run_mode == RUN_INTERACTIVE:
        try:
            res = _interact(proc_name, params[1:])
        except CancelError:
            return
    else:
        res = apply(func, params[1:])

    gimp.displays_flush()

    return res

def main():
    """This should be called after registering the plug-in."""
    gimp.main(None, None, _query, _run)

def fail(msg):
    """Display an error message and quit"""
    gimp.message(msg)
    raise error, msg

def N_(message):
    return message
	
	
#####################################################################################################################################################
############################################# END fu_preview 0.1.1 by Claude Lion $ J.F. Garcia #####################################################
#####################################################################################################################################################

###################################### Start selection-to-gradient-border.py ##########################################################
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net

# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Use "2. Hard Brush 100" to stroke selection instead of clearing with background color
#        produces smoother results.


def python_selection_to_gradient_border_pm(image,layer,border_radius,gradient):

	# Rel 1	
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	pdb.gimp_context_set_sample_transparent(True)
	saved_selection_channel = pdb.gimp_selection_save(image)
	new_layer = pdb.gimp_layer_new(image,image.width,image.height,RGB_IMAGE,'Ring',100,LAYER_MODE_NORMAL_LEGACY)
	pdb.gimp_image_insert_layer(image,new_layer,None,0)
	border_radius = int(border_radius)
	dist = []
	for i in range(border_radius,0,-1):
		dist.append(float(i)/float(border_radius+1))
	num_color_samples,color_samples = pdb.gimp_gradient_get_custom_samples(gradient,border_radius,dist,FALSE)
	for i in range(border_radius,0,-1):
		pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,saved_selection_channel)
		pdb.gimp_selection_border(image,i)
		ci = (border_radius - i)*4
		color = (int(color_samples[ci+0]*255),int(color_samples[ci+1]*255),int(color_samples[ci+2]*255))
		pdb.gimp_context_set_background(color)
		pdb.gimp_edit_clear(new_layer)	
	pdb.gimp_layer_add_alpha(new_layer)
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,saved_selection_channel)
	pdb.gimp_selection_border(image,border_radius)
	pdb.gimp_selection_invert(image)
	pdb.gimp_edit_clear(new_layer)	
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,saved_selection_channel)
	pdb.gimp_image_remove_channel(image,saved_selection_channel)
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)	
	pdb.gimp_displays_flush()
############################################# END selection-to-gradient-border #####################################################	
	
	
####################################################################################################################
################# START gegl_command by Kevin Payne & Claude Lion ##################################################
####################################################################################################################

from sys import platform
from ctypes import *

def load_library (library_name):
	if platform == "linux" or platform == "linux2":
		library_name = library_name + '.so.0'
	elif platform == "win32":
		from ctypes.util import find_library
		library_name = find_library (library_name + "-0")
	else:
		raise BaseException ("TODO")
	return CDLL (library_name)

gimpC = load_library ('libgimp-2.0')


def gegl_planet(image, drawable, gegl_graph_string):
	
	class GeglBuffer(Structure):
		pass
	drawable_id = drawable.ID
	
	gegl = load_library ('libgegl-0.4')
	gegl.gegl_init (None, None)
	gimpC.gimp_drawable_get_shadow_buffer.restype = POINTER (GeglBuffer)
	gimpC.gimp_drawable_get_buffer.restype        = POINTER (GeglBuffer)

	x = c_int (); y = c_int (); w = c_int (); h = c_int ()
	non_empty,x,y,w,h = pdb.gimp_drawable_mask_intersect (drawable)
	args = [b"string", c_char_p (gegl_graph_string), c_void_p ()]
	
	if non_empty:
		source = gimpC.gimp_drawable_get_buffer (drawable_id)
		target = gimpC.gimp_drawable_get_shadow_buffer (drawable_id)
		gegl.gegl_render_op (source, target, "gegl:gegl", *args)
		gegl.gegl_buffer_flush (target)
		gimpC.gimp_drawable_merge_shadow (drawable_id, PushUndo = True)
		gimpC.gimp_drawable_update (drawable_id, x, y, w, h)
		gimpC.gimp_displays_flush ()
		
####################################################################################################################
################# END gegl_command #################################################################################
####################################################################################################################

####################################################################################################################
def centered (image,layer):
	wL = pdb.gimp_drawable_width(layer)
	hL = pdb.gimp_drawable_height(layer)
	wI = pdb.gimp_image_width(image)
	hI = pdb.gimp_image_height(image)
	pdb.gimp_image_set_active_layer(image,layer)

	sw=(wI-wL)/2
	sh=(hI-hL)/2		
	pdb.gimp_layer_set_offsets(layer, sw, sh)
	
def rgb_to_hex(rgb_color):
	r = rgb_color[0]
	g = rgb_color[1]
	b = rgb_color[2]
	return '#%02x%02x%02x' % (r,g,b)
	
def gmic_rgba_to_rgb(rgba_color):

	r = rgba_color[0]
	g = rgba_color[1]
	b = rgba_color[2]

	# write rgb in correct syntax
	rgb_color = "{0},{1},{2}".format(r,g,b)
	return rgb_color

def distrea(image,layer,granularity,spread,smooth,threshold):

	wL = pdb.gimp_drawable_width(layer)
	hL = pdb.gimp_drawable_height(layer)
	theLayer = pdb.gimp_image_get_active_layer(image)
	pdb.gimp_drawable_edit_fill(theLayer, 2) # 2=FILL-WHITE
	pdb.gimp_selection_invert(image)
	pdb.gimp_drawable_edit_clear(theLayer)
	pdb.gimp_selection_invert(image)   
	pdb.gimp_selection_none(image)
	pdb.gimp_layer_scale(theLayer, wL/granularity, hL/granularity, 1)
	pdb.plug_in_spread(image, theLayer, spread, spread)
	pdb.plug_in_gauss_iir(image, theLayer, smooth, 0, 0)
	pdb.gimp_layer_scale(theLayer, wL, hL, 1)
	pdb.plug_in_threshold_alpha(image, theLayer, threshold)
	pdb.plug_in_gauss_iir(image, theLayer, 1, 1, 1)
	pdb.gimp_image_select_item(image, 2, theLayer)
	pdb.gimp_selection_invert(image)
	pdb.gimp_drawable_edit_clear(layer)

#####################################################################################################################	

whoiam = os.path.abspath(sys.argv[0])
locale_directory = os.path.join(os.path.dirname(whoiam), 'locale')
gettext.install("P&M Cosmos", locale_directory, unicode=True )

def render_planet_and_stars(image, layer, 
	create_pl, r_planet, color1, color2, changeColor, planColor, useCustomTexture,customTexture, icePole, ice_angle, ice_thickness, icePoleop,brightness, contrast,
	atmosphere, color_atm, atmosphere_opacity, atmoThickness, moon, addClouds, cloud_color, clouds_opacity,lightning,color_light,
	shadow_phases, sun_Angle, run_long_s, angle_ls, length_ls, midpoint_rel_ls, color_ls,invert_color_ls, color_ls_opacity,
	sm_stars, med_stars, bi_stars, planets, run_stars_gmic, motion_stars_gmic, density, depth, size, thickness, smoothness, color_gmic, add_color, add_nebula, create_brightness,quasar,add_star_burst, color_sb,
	add_ring, burn, dist_r,decrese, border_radius, ring_Angle, gradient,  noise_spread, remove_black, grow, add_shad_ring, corect_angle, corect_x, corect_y, add_stargate, stargate_motion,
	super_nova, color_sn, center_xs, center_ys ,radius_x, spokes_count,  lens_flare, x_pos, y_pos, light_rays, color_lr, density_lr, opacity_lr,
	chirikov_taylor_map, spiral_m, markus_lyapunov_fractal, spiral_f, turbulence, spiral_tur, fractalexplorer, spiral_fe, flame, spiral, magnetar, lines,
	fr_ship, size_ship, preset,beautify, polarize, angle_f, ship, size_space, famous_ships, text, size_text, angle_fs, pixelize, size_pix, colorize, color_ship, neonize, radius_neon, amount_neon, emboss,
	sel_info, meteorize,spiralize_met, length_m, angle_m, comet, factor_c, angle_t, opacity_t, explode, duplicate, tile_size, tile_spacing, color_in, color_out, fire_spred, object_spred,
	elevation_info, what, amplitude_random_deform, d_block, angle_block, resolution, elevation_b, extrude,angle_extr, gradmap, alien_map, elevation,angle_elev, crease,boundary,amplitude_c,frequency_c,
	help, ptab):


	#pdb.gimp_image_undo_group_start(image)
	#pdb.gimp_context_push()
	#pdb.gimp_context_set_defaults()
	pdb.gimp_selection_none(image)	
	for layer in image.layers:
		#pdb.gimp_image_set_active_layer(image,layer)
		pdb.gimp_item_set_visible(layer, 0)

		oldname = layer.name
		layer.name = str(' ') + str(oldname)
			
	wI = pdb.gimp_image_width(image)
	hI = pdb.gimp_image_height(image)

	for vector in image.vectors:
		if vector.name=="Planet Ring":
			pdb.gimp_image_remove_vectors(image,pdb.gimp_image_get_vectors_by_name(image,"Planet Ring"))

	
	new_vectors_d = pdb.gimp_vectors_new(image,"Planet Ring")
	pdb.gimp_image_insert_vectors(image, new_vectors_d, None, -1)	
	pdb.gimp_vectors_bezier_stroke_new_ellipse(new_vectors_d, wI/2, hI/2, r_planet, r_planet, 0)
	
	pdb.gimp_undo_push_group_start(image)
	#variables
	nsm = 0
	xsm = 0
	ysm = 0
	nmd = 0
	xmd = 0
	ymd = 0
	nbi = 0
	xbi = 0
	ybi = 0
	ndt = 0
	xdt = 0
	ydt = 0
	lum = 0

	#wI = pdb.gimp_image_width(image)
	#hI = pdb.gimp_image_height(image)
	
	pdb.gimp_context_set_foreground("White")
	pdb.gimp_context_set_background("Black")
	
	sm=int(sm_stars)
	med=int(med_stars)
	bi=int(bi_stars)
	
	if sm_stars>0:
		starsLayer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Small Stars", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, starsLayer, None, -1)
		pdb.gimp_drawable_fill(starsLayer, FILL_BACKGROUND)
		
		#Creatin small stars
		while (sm_stars > 0):
			pixw = [255, 255, 255]   
			nsm = nsm + 1
			xsm = random.randrange(wI - 1)
			ysm = random.randrange(hI - 1)
			lum = random.randrange(200 + 128)
			pixw[0] = random.randrange(lum + 64)
			pixw[1] = random.randrange(lum + 64)
			pixw[2] = random.randrange(lum + 64)		 
			pdb.gimp_drawable_set_pixel(starsLayer, xsm, ysm, 4, pixw)  
			sm_stars -= 1
		pdb.plug_in_gauss(image, starsLayer, 3, 3, 1)
		pdb.plug_in_normalize(image, starsLayer)
		gegl_planet(image, starsLayer,"hue-chroma hue=-60 chroma=-20 lightness=0.6")
    #Creating medium stars
	if med_stars>0:
		medium_stars = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Medium Stars", 100, LAYER_MODE_NORMAL)	
		pdb.gimp_image_insert_layer(image, medium_stars, None, -1)
		if sm>0:
			pdb.gimp_layer_set_mode(medium_stars, 4)		
		pdb.gimp_drawable_fill(medium_stars, FILL_BACKGROUND)
		while (med_stars > 0):
			pixw = [255, 255, 255]   
			nmd = nmd + 1
			xmd = random.randrange(wI - 2)
			ymd = random.randrange(hI - 2)
			lum = random.randrange(90 + 128)
			pixw[0] = random.randrange(lum + 32)
			pixw[1] = random.randrange(lum + 32)
			pixw[2] = random.randrange(lum + 32)
			pdb.gimp_drawable_set_pixel(medium_stars, xmd, ymd, 4, pixw)
			pdb.gimp_drawable_set_pixel(medium_stars, xmd +1, ymd, 4, pixw)
			pdb.gimp_drawable_set_pixel(medium_stars, xmd, ymd +1, 4, pixw)
			pdb.gimp_drawable_set_pixel(medium_stars, xmd +1, ymd +1, 4, pixw)
			med_stars -= 1
		pdb.plug_in_gauss(image, medium_stars, 5, 5, 1)
		pdb.plug_in_normalize(image, medium_stars)
		gegl_planet(image, medium_stars,"hue-chroma hue=-60 chroma=-20 lightness=0.6")
    #Creating bigs stars
	if bi_stars>0:
		big_stars = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Big Stars", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, big_stars, None, -1)
		if sm>0 or med>0:
			pdb.gimp_layer_set_mode(big_stars, LAYER_MODE_SCREEN)
		pdb.gimp_drawable_fill(big_stars, FILL_BACKGROUND)
		while (bi_stars > 0):
			pixw = [255, 255, 255]   
			nbi = nbi + 1
			xbi = random.randrange(wI - 3)
			ybi = random.randrange(hI - 3)
			lum = random.randrange(63 + 160)
			pixw[0] = random.randrange(lum + 32)
			pixw[1] = random.randrange(lum + 32)
			pixw[2] = random.randrange(lum + 32)
			pdb.gimp_drawable_set_pixel(big_stars, xbi, ybi, 4, pixw)
			pdb.gimp_drawable_set_pixel(big_stars, xbi +1, ybi, 4, pixw)
			pdb.gimp_drawable_set_pixel(big_stars, xbi +2, ybi, 4, pixw)
			pdb.gimp_drawable_set_pixel(big_stars, xbi, ybi +1, 4, pixw)
			pdb.gimp_drawable_set_pixel(big_stars, xbi +1, ybi +1, 4, pixw)
			pdb.gimp_drawable_set_pixel(big_stars, xbi +2, ybi +1, 4, pixw)
			pdb.gimp_drawable_set_pixel(big_stars, xbi, ybi +2, 4, pixw)
			pdb.gimp_drawable_set_pixel(big_stars, xbi +1, ybi +2, 4, pixw)
			pdb.gimp_drawable_set_pixel(big_stars, xbi +2, ybi +2, 4, pixw)
			bi_stars -= 1
		
		pdb.plug_in_gauss(image, big_stars, 5, 5, 1)
		pdb.plug_in_normalize(image, big_stars)
		gegl_planet(image, big_stars,"hue-chroma hue=-60 chroma=-20 lightness=0.6")
    #Creating distants planets
	if planets>0:
		dist_planets = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Distants Planets", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, dist_planets, None, -1)
		if sm>0 or med>0 or bi>0:
			pdb.gimp_layer_set_mode(dist_planets, LAYER_MODE_SCREEN)		
		pdb.gimp_drawable_fill(dist_planets, FILL_BACKGROUND)
		while (planets > 0):
			pixw = [255, 255, 255]   
			ndt = ndt + 1
			xdt = random.randrange(wI - 3)
			ydt = random.randrange(hI - 3)
			lum = random.randrange(63 + 160)
			pixw[0] = random.randrange(lum + 32)
			pixw[1] = random.randrange(lum + 32)
			pixw[2] = random.randrange(lum + 32)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt, ydt, 4, pixw)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt +1, ydt, 4, pixw)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt +2, ydt, 4, pixw)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt, ydt +1, 4, pixw)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt +1, ydt +1, 4, pixw)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt +2, ydt +1, 4, pixw)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt, ydt +2, 4, pixw)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt +1, ydt +2, 4, pixw)
			pdb.gimp_drawable_set_pixel(dist_planets, xdt+2, ydt +2, 4, pixw)
			planets -= 1
		pdb.plug_in_gauss(image, dist_planets, 14, 14, 1)
		pdb.plug_in_normalize(image, dist_planets)
		gegl_planet(image, dist_planets,"hue-chroma hue=-30 chroma=-30 lightness=-15")		
	pdb.gimp_undo_push_group_end(image) 

	if run_stars_gmic:
		hex = gmic_rgba_to_rgb(color_gmic)
		gmicStars = pdb.gimp_layer_new(image, image.width, image.height, RGB_IMAGE, "Stars Gmic", 100, LAYER_MODE_SCREEN)
		pdb.gimp_image_insert_layer(image, gmicStars, None, 0)
		pdb.plug_in_gmic_qt(image, gmicStars, 1, 0, 'fx_stars ' + str(density)+ "," + str(depth)+ "," + str(size)+ "," + '16'+ "," + str(thickness)+ "," + str(smoothness)+ "," + str(hex)+ "," + '255')
		if motion_stars_gmic:
			gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Stars Gmic"),"motion-blur-zoom factor=0.8")
		
	
	if light_rays:
		lightraysLayer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Guided Light Rays", 20, LAYER_MODE_SCREEN)
		pdb.gimp_image_insert_layer(image, lightraysLayer,None, 0)
		pdb.gimp_image_set_active_layer(image,lightraysLayer)
		hexlr=gmic_rgba_to_rgb(color_lr)
		pdb.plug_in_gmic_qt(image, lightraysLayer, 1, 1, 'fx_guided_lightrays 0,1,0,'+ str(density_lr)+',0.87,50,50,50,'+ str(hexlr)+ ',0,'+ str(opacity_lr)+',0')
		pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "[unnamed]"),CLIP_TO_IMAGE)
	#Create the space nebula 
	if add_color:
	#Create the nebula color
		colorLayer = pdb.gimp_layer_new(image, image.width, image.height, RGB_IMAGE, "Color", 100, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, colorLayer, None, 0)
		pdb.gimp_layer_add_alpha(colorLayer)
		pdb.gimp_drawable_fill(colorLayer, FILL_TRANSPARENT)
		pdb.plug_in_plasma(image, colorLayer, 156, 1)
		pdb.gimp_layer_set_opacity(colorLayer, 20)
	if add_nebula:	
	#create the nebula layer
		nebulaLayer = pdb.gimp_layer_new(image, image.width, image.height, RGB_IMAGE, "Nebula", 100, LAYER_MODE_DODGE)
		pdb.gimp_image_insert_layer(image, nebulaLayer, None, 0)
		pdb.gimp_layer_add_alpha(nebulaLayer)
		pdb.gimp_drawable_fill(nebulaLayer, FILL_TRANSPARENT)
		pdb.plug_in_solid_noise(image, nebulaLayer, FALSE, FALSE, 20, 15, 5, 5)
		pdb.gimp_layer_set_mode(nebulaLayer, LAYER_MODE_DODGE)
		
	if create_brightness:	
	#Create brightness on the background stars an nebula
		beautyLayer = pdb.gimp_layer_new(image, image.width, image.height, RGB_IMAGE, "Brightness", 5, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, beautyLayer, None,1)
		pdb.gimp_context_set_foreground("Black")
		pdb.gimp_drawable_fill(beautyLayer, FILL_FOREGROUND)
		pdb.plug_in_nova(image, beautyLayer, 960, 540, (000, 000, 255), 300, 1, 0)
		
	if quasar:
		quasarLayer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Quasar", 100, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, quasarLayer,None, 0)
		pdb.gimp_context_set_foreground(color2) # (90, 180, 180)
		pdb.gimp_drawable_fill(quasarLayer, FILL_FOREGROUND)
		pdb.gimp_image_select_ellipse(image, 2, image.width/4, image.height/4, image.width/2, image.height/2)
		pdb.gimp_selection_invert(image)
		pdb.gimp_drawable_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Quasar"))
		pdb.gimp_selection_none(image)
		pdb.plug_in_gmic_qt(image, quasarLayer, 1, 0,'fx_crease 100,100,0')
		pdb.plug_in_gmic_qt(image, quasarLayer, 1, 0,'deform 5')
		
	if add_star_burst:
		burstLayer = pdb.gimp_layer_new(image, wI, hI, RGBA_IMAGE, "Star Burst", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(image, burstLayer, 0)
		#pdb.gimp_drawable_fill(burstLayer, FILL_TRANSPARENT) 
		pdb.gimp_image_select_ellipse(image, 2, wI/2-hI/4, hI/2-hI/4, hI/2, hI/2)
		#Create the two bars gradient
		actual_name = pdb.gimp_gradient_new("Two bars")
		pdb.gimp_gradient_segment_range_replicate(actual_name, 0, 1.0000, 4)
		#First bar
		pdb.gimp_gradient_segment_set_left_color(actual_name, 0.0000, (0,0,0), 0)
		pdb.gimp_gradient_segment_set_right_color(actual_name, 0.2500, (0,0,0), 0)
		#Second bar
		final_pos = pdb.gimp_gradient_segment_set_left_pos(actual_name, 1, 0.2500)
		pdb.gimp_gradient_segment_set_left_color(actual_name, 1, (255,255,255), 100)
		#Third bar
		pdb.gimp_gradient_segment_set_left_color(actual_name, 2, (0,0,0), 0)
		pdb.gimp_gradient_segment_set_right_color(actual_name, 2, (0,0,0), 0)
		#Fourth bar
		final_pos = pdb.gimp_gradient_segment_set_left_pos(actual_name, 3, 0.7500)
		pdb.gimp_gradient_segment_set_left_color(actual_name, 3, (255,255,255), 100)
		
		pdb.gimp_context_set_gradient("Two bars")
		pdb.gimp_context_set_gradient_repeat_mode(REPEAT_SAWTOOTH)
		pdb.gimp_drawable_edit_gradient_fill(burstLayer, 
		2,     #gradient type - radial
		0,     #offset
		TRUE,  #super sample
		3,     #supersample-max depth
		0.20,  #supersample-threshole
		TRUE,  #dither
		image.width/2,   #x1
		image.height/2,  #y1
		image.width/2+image.height/6,  #x2
		image.height/2)                #y2
		
		#Delete created gradient
		pdb.gimp_gradient_delete("Two bars")

		pdb.gimp_selection_none(image)
		pdb.plug_in_hsv_noise(image, burstLayer, 1, 0, 0, 50)
		pdb.gimp_drawable_invert(burstLayer, FALSE)
		pdb.plug_in_colortoalpha(image, burstLayer, "Black")
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Star Burst"),"motion-blur-zoom factor=0.3")		
		pdb.gimp_layer_scale(burstLayer, wI, 2*hI/3, TRUE)
		burstLayer = pdb.gimp_item_transform_rotate(burstLayer, -0.5, TRUE, 0, 0)
		pdb.gimp_layer_resize_to_image_size(burstLayer)
		pdb.plug_in_colorify(image, burstLayer, color_sb)
		#pdb.gimp_image_select_item(image, 2, burstLayer)
		#pdb.gimp_selection_invert(image)
		color_to_sb=rgb_to_hex(color_sb)
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Star Burst"), "supernova radius=5 color=%s" % (color_to_sb))
		pdb.gimp_selection_none(image)
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Star Burst"),"motion-blur-zoom factor=0.2")
		pdb.gimp_layer_set_mode(pdb.gimp_image_get_layer_by_name(image, "Star Burst"), LAYER_MODE_HARDLIGHT)
		
# tab Strange
	
	if chirikov_taylor_map:
		chtLayer = pdb.gimp_layer_new(image, image.width, image.height, RGB_IMAGE, "Chirikov-Taylor", 30, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, chtLayer, None, 0)
		pdb.plug_in_gmic_qt(image, chtLayer, 1, 0, 'fx_rep_cstdmap ' + str(random.randrange(300,2500))+ ',5000,1,0,0,0,1,1,1,1,0,2,0,20,0')	
		pdb.gimp_image_raise_item_to_top(image, pdb.gimp_image_get_layer_by_name(image, "Chirikov-Taylor #1"))
		chtLayer=pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Chirikov-Taylor #1"), CLIP_TO_IMAGE)
		pdb.gimp_layer_set_mode(chtLayer, LAYER_MODE_LCH_COLOR)
		pdb.plug_in_gmic_qt(image, chtLayer, 1, 0,'deform 10')
	
	if spiral_m==1 and chirikov_taylor_map==1:
		pdb.plug_in_gmic_qt(image, chtLayer, 1, 0, 'gui_rep_sd 1,1,0,0,0,0,50,50,0,50,50,1,50,50,100,100,3,4,0,50,21')
		
	if markus_lyapunov_fractal:
		mlLayer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Markus-Lyapunov", 30, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, mlLayer, None, 0)
		pdb.plug_in_gmic_qt(image, mlLayer, 1, 0, 'fx_rep_mlfrac "ab",50,1,' + str(random.randrange(10,100))+',50,50,50,3,0,0,0,255,255,255,255,0,255,1,0,8,8,8,0,' + str(random.randrange(1,223)) + ',0,16,0,50,0,8,0,8,0,8,0,0,0,0,"","","",8,0,8,0,8,0,0,0')
		pdb.gimp_layer_set_mode(mlLayer, LAYER_MODE_LCH_COLOR)
		
	if markus_lyapunov_fractal==1 and spiral_f==1:
		pdb.plug_in_gmic_qt(image, mlLayer, 1, 0, 'gui_rep_sd 1,1,0,0,0,0,50,50,0,50,50,1,50,50,100,100,3,4,0,50,21')	

	if turbulence!=5:
		turLayer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Turbulence", 20, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, turLayer, None, 0)	
	
	if turbulence==0:
		pdb.plug_in_gmic_qt(image, turLayer, 1, 0, 'fx_turbulence 128,6,4,0,0')
	if turbulence==1:
		pdb.plug_in_gmic_qt(image, turLayer, 1, 0, 'fx_turbulence 128,6,4,0,1')
	if turbulence==2:
		pdb.plug_in_gmic_qt(image, turLayer, 1, 0, 'fx_turbulence 128,6,4,0,2')
	if turbulence==3:
		pdb.plug_in_gmic_qt(image, turLayer, 1, 0, 'fx_turbulence 128,6,4,0,3')
	if turbulence==4:
		pdb.plug_in_gmic_qt(image, turLayer, 1, 0, 'fx_turbulence 128,6,4,0,4')
		
	if spiral_tur==1 and turbulence !=5:
		pdb.plug_in_gmic_qt(image, turLayer, 1, 0, 'gui_rep_sd 1,1,0,0,0,0,50,50,0,50,50,1,50,50,100,100,3,4,0,50,21')
	
	if fractalexplorer:
		feLayer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Fractal Explorer", 50, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, feLayer, None, 0)
		pdb.plug_in_fractalexplorer(image, feLayer, 1, 5.0, 5.0, 5.0, 5.0, 5.0, 5.0, 5.0, 1, 5.0, 5.0, 5.0, 1, 1, 1, 1, 1, 1, 1, run_mode=RUN_INTERACTIVE)

	if fractalexplorer==1 and spiral_fe==1:
		pdb.plug_in_gmic_qt(image, feLayer, 1, 0, 'gui_rep_sd 1,1,0,0,0,0,50,50,0,50,50,1,50,50,100,100,3,4,0,50,21')
		
	if flame:	
		flameLayer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Flame", 100, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, flameLayer, None, 0)
		pdb.plug_in_flame(image, flameLayer, run_mode=RUN_INTERACTIVE)
			
	if flame==1 and spiral==1:
		pdb.plug_in_gmic_qt(image, flameLayer, 1, 0, 'gui_rep_sd 1,1,0,0,0,0,50,50,0,50,50,1,50,50,100,100,3,4,0,50,21')

	if magnetar==1:

		group_new = pdb.gimp_layer_group_new(image)
		parent = pdb.gimp_item_get_parent(group_new)
		position = pdb.gimp_image_get_item_position(image, layer)
		pdb.gimp_image_insert_layer(image,group_new, None, 0) 
		group_new.name = "Magnetar PixLab"
		add_mag=gimp.Layer(image, "Magnetar", wI,hI, RGBA_IMAGE, 100, 0)
		pdb.gimp_image_insert_layer(image, add_mag, None, -1)
		pdb.gimp_image_reorder_item(image, add_mag, group_new, position)
		pdb.gimp_selection_none(image)

		wI2=wI/2
		hI2=hI/2
		
		x_r=wI2-r_planet*2
		y_r=hI2-r_planet*1.5
		width_r=r_planet*2
		height_r=r_planet*3
		
		pdb.gimp_image_select_ellipse(image, 2, x_r, y_r, width_r, height_r)
		pdb.gimp_context_set_foreground((0,0,255))

		pdb.gimp_context_set_brush("1. Pixel")
		pdb.gimp_context_set_brush_size(20)
		pdb.gimp_context_set_brush_default_hardness()
		pdb.gimp_context_set_brush_spacing(0.01)
		pdb.gimp_context_set_paint_method("gimp-paintbrush")
		pdb.gimp_context_set_brush_aspect_ratio(1.5)
		pdb.gimp_context_set_brush_angle(17.5)
		pdb.gimp_context_set_dynamics("Dynamics Off") 	
		pdb.gimp_drawable_edit_stroke_selection(add_mag)
		pdb.gimp_selection_none(image)
		pdb.plug_in_gauss(image, add_mag, 5, 5, 1)
		pdb.gimp_layer_set_offsets( add_mag, r_planet/6, 0)
		pdb.gimp_layer_resize_to_image_size(add_mag)
		
		many=0	
		for item in range(1,int(lines)):
			copy = pdb.gimp_layer_copy(pdb.gimp_image_get_layer_by_name(image, "Magnetar"), TRUE)
			pdb.gimp_image_insert_layer(image, copy, None, -1)
			m_r_x=wI+(many+1)*r_planet*2
			m_r_y=hI+(many+1)*r_planet
			pdb.gimp_layer_scale(copy,m_r_x, m_r_y, 1)
			if r_planet>100:
				pdb.plug_in_gauss(image, copy, 10+many*2, 10+many*2, 1)
			many=many+1

		pdb.gimp_image_merge_layer_group(image, group_new)
		layer_copy = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, "Magnetar PixLab"),image)
		pdb.gimp_image_insert_layer(image, layer_copy, None, -1)
		pdb.gimp_item_transform_flip_simple(layer_copy, 0, FALSE, wI2)
		pdb.gimp_image_merge_down(image, layer_copy, 0)
		pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Magnetar PixLab"))

		if r_planet>100:
			pdb.plug_in_gauss(image, pdb.gimp_image_get_layer_by_name(image, "Magnetar PixLab"), r_planet*0.4, r_planet*0.4, 1)		
		
		add_grad=gimp.Layer(image, "Gradient", wI,hI, RGBA_IMAGE, 100, 0)
		pdb.gimp_image_insert_layer(image, add_grad, None, -1)	
		pdb.gimp_context_set_gradient("Incandescent")
		pdb.gimp_blend(add_grad,BLEND_CUSTOM,LAYER_MODE_NORMAL,GRADIENT_RADIAL ,100,0,REPEAT_NONE,True,False,3,0.2,True,wI2,hI2,wI2,hI2+r_planet*7)
		pdb.gimp_layer_set_mode(add_grad, LAYER_MODE_HSV_HUE)
		pdb.gimp_image_raise_item_to_top(image, add_grad)
		pdb.gimp_selection_none(image)
		
	if magnetar==2:
		
		group_new = pdb.gimp_layer_group_new(image)
		parent = pdb.gimp_item_get_parent(group_new)
		position = pdb.gimp_image_get_item_position(image, layer)
		pdb.gimp_image_insert_layer(image,group_new, None, 0) 
		group_new.name = "Magnetar PixLab"
		add_mag=gimp.Layer(image, "Magnetar", wI,hI, RGBA_IMAGE, 100, 0)
		pdb.gimp_image_insert_layer(image, add_mag, None, -1)
		pdb.gimp_image_reorder_item(image, add_mag, group_new, position)
		pdb.gimp_selection_none(image)

		wI2=wI/2
		hI2=hI/2
		
		x_r=wI2-r_planet*2
		y_r=hI2-r_planet*1.5
		width_r=r_planet*2
		height_r=r_planet*3
		
		pdb.gimp_image_select_ellipse(image, 2, x_r, y_r, width_r, height_r)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_drawable_edit_fill(add_mag, 0)
		pdb.gimp_selection_none(image)
		gegl_planet(image, add_mag, "dropshadow x=-10 y=0 radius=10 opacity=0.1")
		pdb.gimp_selection_none(image)
		
		many=0	
		for copy in range(1,int(lines)):
			copy = pdb.gimp_layer_copy(pdb.gimp_image_get_layer_by_name(image, "Magnetar"), TRUE)
			pdb.gimp_image_insert_layer(image, copy, None, -1)
			m_r_x=wI+(many+1)*r_planet*4
			m_r_y=hI+(many+1)*r_planet*3
			pdb.gimp_layer_scale(copy,m_r_x, m_r_y, 1)
			pdb.gimp_layer_resize_to_image_size(copy)
			pdb.gimp_layer_set_opacity(copy,100-100*(many+1)/int(lines))
			gegl_planet(image, copy, "dropshadow x=-10 y=0 radius=10 opacity=0.1")
			pdb.gimp_image_lower_item_to_bottom(image, copy)
			many=many+1

		pdb.gimp_image_merge_layer_group(image, group_new)
		layer_copy = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, "Magnetar PixLab"),image)
		pdb.gimp_image_insert_layer(image, layer_copy, None, -1)
		pdb.gimp_item_transform_flip_simple(layer_copy, 0, FALSE, wI2)
		pdb.gimp_image_merge_down(image, layer_copy, 0)
		pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Magnetar PixLab"))
		pdb.gimp_selection_none(image)
	## Planet
	if create_pl!=0:	
		planetLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, 1, "Planet Sources", 100, 0)	# RGBA-IMAGE (1)
		pdb.gimp_image_insert_layer(image, planetLayer, None, 0)
		centered(image, planetLayer)

	if create_pl==1:	
		pdb.plug_in_solid_noise(image, planetLayer, FALSE, FALSE, int(time.time()), 15, 3, 3)
		pdb.gimp_drawable_desaturate(planetLayer, DESATURATE_LUMINANCE)
		pdb.gimp_levels(planetLayer, HISTOGRAM_RED, 255, 255, 1.00, 0, 255)
		pdb.gimp_drawable_hue_saturation(planetLayer, ALL_HUES, -14, 20, -20, 0)

	 #Shadow color balance
		pdb.gimp_color_balance(planetLayer, 
											 0,   #transfer_mode - shadows
										  TRUE,   #preserve_lum
										  -100,   #cyan_red
										   100,   #magenta_green,
										  -100)   #yellow_blue
		#Midtones color balance
		pdb.gimp_color_balance(planetLayer, 
											 1,   #transfer_mode - midtones
										  TRUE,   #preserve_lum
										  -100,   #cyan_red
										  -100,   #magenta_green,
										   100)   #yellow_blue                                 
		#Hightlights color balance
		pdb.gimp_color_balance(planetLayer, 
											 2,   #transfer_mode - hightlight
										 FALSE,   #preserve_lum
										  -100,   #cyan_red
										  -100,   #magenta_green,
										   100)   #yellow_blue      
				
		#Hightlights color balance
		pdb.gimp_color_balance(planetLayer, 
											 2,   #transfer_mode - hightlight
										 FALSE,   #preserve_lum
											50,   #cyan_red
											 -10, #magenta_green,
											20)   #yellow_blue   
					   
		#Convert the square to a circle
		pdb.plug_in_emboss(image, planetLayer, 90, 100, 7, FALSE)
		pdb.plug_in_applylens(image, planetLayer, 1.8, FALSE, FALSE, TRUE)
		
	if create_pl==2:
		origForeColor = pdb.gimp_context_get_foreground()
		origBackColor = pdb.gimp_context_get_background()
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_context_set_background(color2)
		pdb.gimp_selection_none(image)
		pdb.gimp_selection_none(image)

		#Add Water Color
		pdb.gimp_edit_fill(planetLayer, FILL_FOREGROUND)

		#Adding waterTextureLayer
		waterTextureLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Water Texture", 100.0, LAYER_MODE_OVERLAY_LEGACY)
		pdb.gimp_image_insert_layer(image, waterTextureLayer,None, 0)
		centered(image,waterTextureLayer)
		#Render waterTextureLayer with plasma
		pdb.plug_in_plasma(image, waterTextureLayer, random.randrange(1,999999999), 4.0)
		pdb.gimp_desaturate(waterTextureLayer)

		#Merging Water Layers
		pdb.gimp_image_merge_down(image, waterTextureLayer, 0)
		color_1_layer = pdb.gimp_image_get_active_layer(image)

		bumpmapLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Bump Map", 100.0,  LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, bumpmapLayer,None, 0)
		pdb.gimp_image_set_active_layer(image, bumpmapLayer)
		centered(image,bumpmapLayer)
		pdb.gimp_selection_none(image)

		#Render bumpmapLayer with plasma
		pdb.plug_in_plasma(image, bumpmapLayer, random.randrange(1,999999999), 4.0)
		pdb.gimp_desaturate(bumpmapLayer)

		#Hide Bump Map
		pdb.gimp_drawable_set_visible(bumpmapLayer, FALSE)
		
		#Map Bump Map to Sphere
		pdb.plug_in_map_object(image, bumpmapLayer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.91, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
				0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
				TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, bumpmapLayer, bumpmapLayer, bumpmapLayer, bumpmapLayer, bumpmapLayer, bumpmapLayer, bumpmapLayer, bumpmapLayer)

		#Adding landColorLayer
		landColorLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Land Color", 100.0, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, landColorLayer,None, 0)
		centered(image,landColorLayer)
		#Add Land Color
		pdb.gimp_edit_fill(landColorLayer, FILL_BACKGROUND)

		#Adding landTextureLayer1
		landTextureLayer1 = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Land Texture 1", 100.0, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, landTextureLayer1, None, 0)
		centered(image,landTextureLayer1)
		#Setting foreground color to black
		pdb.gimp_context_set_foreground((0,0,0))

		#Render landTextureLayer1 with clouds
		pdb.gimp_edit_fill(landTextureLayer1, FILL_FOREGROUND)
		pdb.plug_in_solid_noise(image, landTextureLayer1, 1, 0, random.randrange(1,9999999999), 1, 4.0, 4.0)

		#Adding landTextureLayer2
		landTextureLayer2 = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Land Texture 2", 100.0,  LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, landTextureLayer2,None, 0)
		centered(image,landTextureLayer2)
		#Render landTextureLayer2 with clouds
		pdb.gimp_edit_fill(landTextureLayer2, FILL_FOREGROUND)
		pdb.plug_in_solid_noise(image, landTextureLayer2, 1, 0, random.randrange(1,999999999), 1, 4.0, 4.0)
		pdb.gimp_layer_set_mode(landTextureLayer2, LAYER_MODE_DIFFERENCE_LEGACY)

		#Merging both texture layers and setting mode to overlay
		pdb.gimp_image_merge_down(image, landTextureLayer2, 0)
		landTextureLayer = pdb.gimp_image_get_active_layer(image)
		pdb.gimp_layer_set_mode(landTextureLayer, LAYER_MODE_OVERLAY_LEGACY)# LAYER_MODE_LUMA_LIGHTEN_ONLY
		pdb.gimp_image_merge_down(image, landTextureLayer, 0)
		color_2_layer = pdb.gimp_image_get_active_layer(image)
		pdb.gimp_layer_set_mode(color_2_layer, LAYER_MODE_LUMA_LIGHTEN_ONLY)
		
		#Map landmass and water layer to a sphere
		pdb.plug_in_map_object(image, color_1_layer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
				0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
				TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, color_1_layer, color_1_layer, color_1_layer, color_1_layer, color_1_layer, color_1_layer, color_1_layer, color_1_layer)
				
		pdb.plug_in_map_object(image, color_2_layer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
				0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
				TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, color_2_layer, color_2_layer, color_2_layer, color_2_layer, color_2_layer, color_2_layer, color_2_layer, color_2_layer)
		pdb.gimp_drawable_set_visible(bumpmapLayer, 1)
		pdb.gimp_layer_set_mode(bumpmapLayer, LAYER_MODE_LINEAR_LIGHT)
		pdb.gimp_selection_none(image)

		pdb.gimp_context_set_foreground(origForeColor)
		pdb.gimp_context_set_background(origBackColor)
		
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Bump Map"), 0)
		planetLayer=pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Land Color"), 0)
		pdb.gimp_selection_invert(image)		
		pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))		
		centered(image,pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))		
		pdb.gimp_selection_none(image)
		
	if create_pl==3:	# Texture and Second Color

		seed = random.randrange(0,4294967296)
		pdb.gimp_context_set_pattern(customTexture)
		pdb.gimp_edit_fill(planetLayer, FILL_PATTERN)
		color2layer = pdb.gimp_layer_new(image,r_planet*2, r_planet*2,RGBA_IMAGE,"color 2",100,LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image,color2layer,None,-1)
		centered(image,color2layer)
		pdb.plug_in_solid_noise(image,color2layer,1,0,seed,1,9.0,9.0)
		pdb.plug_in_gauss(image, color2layer, 5, 5, 1)
		pdb.gimp_threshold(color2layer,126,255)
		pdb.gimp_image_select_color(image,CHANNEL_OP_REPLACE,color2layer,(0,0,0)) #(255,255,255)
		distrea(image,color2layer,4,5,5,127)
		pdb.gimp_edit_cut(color2layer)		
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_cut(color2layer)
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(color2layer,FOREGROUND_FILL)
		pdb.plug_in_gmic_qt(image, color2layer, 1, 0, 'fx_mineral_mosaic 3,32,10,0,0') #
		pdb.plug_in_gauss(image, color2layer, 5, 5, 1)
		pdb.gimp_selection_none(image)
		planetLayer=pdb.gimp_image_merge_down(image, color2layer, 0)
		centered(image,planetLayer)
		pdb.plug_in_map_object(image, planetLayer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
		0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
		TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, planetLayer, planetLayer, planetLayer, planetLayer, planetLayer, planetLayer, planetLayer, planetLayer)		
		pdb.plug_in_bump_map(image, planetLayer,planetLayer,  90.0, 60.0, 10, 0, 0, 0, 0, TRUE, 0, 1) #TRUE FALSE
		pdb.gimp_image_select_item(image, 2, new_vectors_d)			
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(planetLayer)

	if create_pl==4:	# Gas-Planet\n(First Color)
		gasLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Gas Planet", 75, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, gasLayer, None,0)
		centered(image,gasLayer)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(planetLayer, 0)
		pdb.plug_in_solid_noise(image, gasLayer, FALSE, TRUE, int(time.time()), 15, 0, 15)
		#pdb.plug_in_gauss(image, gasLayer, 25, 25, 1)   #method=1
		pdb.plug_in_ripple(image, gasLayer, 200, 2, 1, 0, 1, TRUE, TRUE)
		#pdb.plug_in_hsv_noise(image, gasLayer, 8, 0, 0, 255) 
		pdb.plug_in_gauss(image, gasLayer, 20, 20, 1)   #method=1
		pdb.gimp_layer_set_mode(gasLayer, LAYER_MODE_MULTIPLY_LEGACY)	#?? LAYER_MODE_LUMINANCE LAYER_MODE_GRAIN_MERGE 
	
		planetLayer = pdb.gimp_image_merge_down(image, gasLayer, CLIP_TO_IMAGE)
      # pdb.plug_in_map_object(image, drawable, maptype, viewpoint_x, viewpoint_y, viewpoint_z, position_x, position_y, position_z, firstaxis_x, firstaxis_y, firstaxis_z, secondaxis_x, secondaxis_y, secondaxis_z,
		pdb.plug_in_map_object(image, planetLayer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
      # rotationangle_x, rotationangle_y, rotationangle_z, lighttype, lightcolor, lightposition_x, lightposition_y, lightposition_z, lightdirection_x, lightdirection_y, lightdirection_z, ambient_intensity, diffuse_intensity, diffuse_reflectivity, specular_reflectivity, highlight, 
		0.0, 0.0, 40.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
	  # antialiasing, tiled, newimage, transparentbackground, radius, x_scale, y_scale, z_scale, cylinder_length, box_front_drawable, box_back_drawable, box_top_drawable, box_bottom_drawable, box_left_drawable, box_right_drawable, cyl_top_drawable, cyl_bottom_drawable)			
		TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, planetLayer, planetLayer, planetLayer, planetLayer, planetLayer, planetLayer, planetLayer, planetLayer)
	
	if create_pl==5:	# Lava
		lavaLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Lava Planet", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, lavaLayer, None,0)
		centered(image,lavaLayer)
		pdb.gimp_context_set_gradient("Incandescent")
		pdb.gimp_blend(lavaLayer,BLEND_CUSTOM,LAYER_MODE_NORMAL,GRADIENT_RADIAL ,100,0,REPEAT_NONE,False,False,3,0.2,True,lavaLayer.width/2,lavaLayer.height/2,lavaLayer.width/2,lavaLayer.height)
		pdb.plug_in_gmic_qt(image, lavaLayer, 1, 0, 'fx_lava 15,20,3,0,0,50,50')
		pdb.plug_in_gmic_qt(image, lavaLayer, 1, 0, 'deform 30')
		pdb.plug_in_gauss(image, lavaLayer, 2, 2, 1)
		pdb.plug_in_emboss(image, lavaLayer, 90, 100, 7, False)		
		pdb.plug_in_map_object(image, lavaLayer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
		0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
		TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, lavaLayer, lavaLayer, lavaLayer, lavaLayer, lavaLayer, lavaLayer, lavaLayer, lavaLayer)		
		planetLayer = pdb.gimp_image_merge_down(image, lavaLayer, CLIP_TO_IMAGE)
	
	if create_pl==6:	# Alien 1 Popcorn 
		alien1Layer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Popcorn Planet", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, alien1Layer,None, 0)
		pdb.plug_in_gmic_qt(image, alien1Layer, 1, 0, 'fx_rep_pfrac 50,1,0.05,' + str(random.randrange(1,20))+',0.5,45,50,50,0,0,0,1,3,1,0,1,0,4,0,5,0,5,1,0,0,1,3,1,0,1,0,4,0,5,0,5,1,2,0,1,1,0')		
		pdb.plug_in_map_object(image, alien1Layer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
		0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
		TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, alien1Layer, alien1Layer, alien1Layer, alien1Layer, alien1Layer, alien1Layer, alien1Layer, alien1Layer)
		pdb.plug_in_emboss(image, planetLayer, 90, 100, 7, False)
		pdb.plug_in_gmic_qt(image, alien1Layer, 1, 0,'fx_random_pattern ' + str(r_planet*2)+',2,' + str(random.randrange(1000,99999))+ ',0,0,0,0,0,0')
		pdb.gimp_layer_set_mode(pdb.gimp_image_get_layer_by_name(image, "Popcorn Planet"), LAYER_MODE_GRAIN_MERGE_LEGACY)
		planetLayer = pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Popcorn Planet"), CLIP_TO_IMAGE)
		centered(image,planetLayer)
		planetLayer = pdb.gimp_image_merge_down(image, planetLayer, CLIP_TO_IMAGE)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)			
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(planetLayer)
		pdb.gimp_selection_none(image)		
		
	if create_pl==7:	# Alien 2 Newton 
		alien2Layer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Newton Planet", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, alien2Layer, None,0)
		centered(image,alien2Layer)
		pdb.plug_in_gmic_qt(image, alien2Layer, 1, 0, 'fx_newton_fractal "-2","-2","2","2",2,"rot(35?)*z^^3 - z^^2 + 1","3*z^^2 - 2*z","6*z - 2",2,200,2,0,16,8,255,2,100,150,20,400,3,2,"carg(-z)","(i0 + i1)/2","10*(i2^0.4)",0,0,0,0,0,0,0,2,"0",50,50,0.5,0,0,0,0,0,1,2')
		pdb.plug_in_gmic_qt(image, alien2Layer, 1, 0,'fractalize 0.5')
		pdb.plug_in_map_object(image, alien2Layer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
		0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
		TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, alien2Layer, alien2Layer, alien2Layer, alien2Layer, alien2Layer, alien2Layer, alien2Layer, alien2Layer)		
		planetLayer = pdb.gimp_image_merge_down(image, alien2Layer, CLIP_TO_IMAGE)
		pdb.plug_in_emboss(image, planetLayer, 90, 100, 7, False)

	if create_pl==8:	# Alien 3
		alien3Layer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Complex Planet", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, alien3Layer, None,0)
		centered(image,alien3Layer)
		pdb.plug_in_gmic_qt(image, alien3Layer, 1, 0, 'fx_rep_compb 50,1,0.05,' + str(random.randrange(-15,15)) + ',3,3,2,0,50,50,0,0,1,0,1,2,0,1,2,0,1,2,0.5,0.5,1,1,0')
		pdb.plug_in_map_object(image, alien3Layer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
		0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
		TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, alien3Layer, alien3Layer, alien3Layer, alien3Layer, alien3Layer, alien3Layer, alien3Layer, alien3Layer)		
		planetLayer = pdb.gimp_image_merge_down(image, alien3Layer, CLIP_TO_IMAGE)
		pdb.plug_in_emboss(image, planetLayer, 90, 100, 7, False)
		pdb.plug_in_gmic_qt(image, planetLayer, 1, 0, 'fx_light_relief 0.3,0.2,0.2,0,1,50,50,5,0.5,0,0')
		
	if create_pl==9: # Random_Plasma
	
		randplLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGB_IMAGE, "Random Plasma", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, randplLayer, None,0)	
		pdb.plug_in_gmic_qt(image, randplLayer, 1, 0, 'samj_Random_Plasma 4,80')
		pdb.gimp_layer_add_alpha(randplLayer)
		pdb.plug_in_applylens(image, randplLayer, 1.8, FALSE, FALSE, TRUE)
		centered(image,pdb.gimp_image_get_layer_by_name(image, "Random Plasma"))
		pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Random Plasma"), 0)
		pdb.gimp_selection_none(image)
		pdb.plug_in_gauss(image, pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), 2, 2, 1)
		
	if create_pl==10: # Dirty
		dirtyLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Dirty", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, dirtyLayer, None,0)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)			
		pdb.gimp_edit_clear(dirtyLayer)
		centered(image,dirtyLayer)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(dirtyLayer, 0)
		dirt = pdb.gimp_layer_new_from_drawable(dirtyLayer, image)
		pdb.gimp_image_insert_layer(image, dirt, None, 0)
		pdb.plug_in_gmic_qt(image, dirt, 1, 0, 'fx_dirty 70,0,0,0,0,50,50')
		pdb.plug_in_gmic_qt(image, dirt, 1, 0,'deform 15')
		pdb.gimp_image_merge_down(image, dirt, 0)
		planetLayer=pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Dirty"), 0)
		pdb.gimp_selection_none(image)

	if create_pl==11: # wrinkled
		wrinkledLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Wrinkled", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, wrinkledLayer, None,0)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		
		centered(image,wrinkledLayer)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(wrinkledLayer, 0)
		hol = pdb.gimp_layer_new_from_drawable(wrinkledLayer, image)
		pdb.gimp_image_insert_layer(image, hol, None, 0)
		pdb.plug_in_gmic_qt(image, hol, 1, 0, 'fx_turbulence ' + str(random.randrange(30,150)) + ',6,4,0,4')
		pdb.gimp_drawable_desaturate(hol, 4)
		# pdb.plug_in_bump_map(image, drawable, bumpmap, azimuth, elevation, depth, xofs, yofs, waterlevel, ambient, compensate, invert, type)
		pdb.plug_in_bump_map(image, pdb.gimp_image_get_layer_by_name(image, "Wrinkled"), hol, 8, 4.0, 3, 0, 0, 0, 0, FALSE, TRUE, 1)
		pdb.gimp_layer_set_mode(hol, LAYER_MODE_DIVIDE_LEGACY) 
		pdb.gimp_image_merge_down(image, hol, 0)
		pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Wrinkled"), 0)
		pdb.plug_in_applylens(image, pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), 2, FALSE, FALSE, TRUE)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)	
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))		
		pdb.gimp_selection_none(image)

	if create_pl==12: # crater
		craterLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Cratered", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, craterLayer, None, -1)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		centered(image,craterLayer)		

		pdb.gimp_context_set_foreground((128,128,128))
		pdb.gimp_edit_fill(craterLayer, 0)
		pdb.gimp_selection_none(image)

		noise = pdb.gimp_layer_new_from_drawable(craterLayer, image)
		pdb.gimp_image_insert_layer(image,noise, None, -1)
		centered(image,noise)		
		pdb.plug_in_solid_noise(image, noise, 1, 1, random.randrange(1000,999999999), 10, 5.0, 5.0)
		pdb.gimp_layer_set_mode(noise, LAYER_MODE_GRAIN_MERGE_LEGACY)
		pdb.plug_in_hsv_noise(image, craterLayer,6, 150, 0, 255)		
		
		mer=pdb.gimp_image_merge_down(image, noise, 0)
		pdb.plug_in_gauss(image,mer, 3, 3, 1)
		gmicLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Gmic", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image,gmicLayer, None, -1)
		centered(image,gmicLayer)
		
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_context_set_foreground((0,0,0))
		pdb.gimp_edit_fill(gmicLayer, 0)
		pdb.gimp_selection_invert(image)		
		pdb.gimp_edit_clear(gmicLayer)
		pdb.gimp_selection_invert(image)		
		pdb.plug_in_gmic_qt(image, gmicLayer, 1, 0, 'fx_stars 1.8,2.54,55,16,0.6166,6.73,255,255,255,255')
		centered(image,pdb.gimp_image_get_layer_by_name(image, "Gmic"))
		pdb.plug_in_applylens(image,pdb.gimp_image_get_layer_by_name(image, "Gmic"), 1.8, FALSE, FALSE, TRUE)
		pdb.plug_in_gauss(image,gmicLayer, 5, 5, 1)
		pdb.plug_in_emboss(image, pdb.gimp_image_get_layer_by_name(image, "Gmic"), 90, 100, 7, True)
		pdb.plug_in_bump_map(image, pdb.gimp_image_get_layer_by_name(image, "Cratered"),pdb.gimp_image_get_layer_by_name(image, "Gmic"), 135, 25, 4, 0, 0, 0, 0,TRUE, FALSE, 1)
		pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Gmic"))
		pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Gmic"), 0)
		planetLayer=pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Cratered"), 0)	
		pdb.gimp_selection_none(image)
		
	if create_pl!=0:	
		pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
	
	if create_pl==13: # Simple
		color_b=gmic_rgba_to_rgb(color1)
		b_planet=r_planet*2
		pdb.plug_in_gmic_qt(image, planetLayer, 1, 0, 'fx_ball '  + str(b_planet) +',0,4,0.8,'+ str(color_b))
		centered(image, pdb.gimp_image_get_layer_by_name(image, "Ball"))
		#pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Ball"),0)
		
	if create_pl==14: # Pointillisme
		ashLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Pointillisme", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, ashLayer, None,0)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)			
		pdb.gimp_edit_clear(ashLayer)
		centered(image,ashLayer)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_context_set_background(color2)
		pdb.gimp_edit_fill(ashLayer,FOREGROUND_FILL)
		layer_copy_a = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, "Pointillisme"),image)
		pdb.gimp_image_insert_layer(image, layer_copy_a, None, -1)		
		pdb.gimp_edit_fill(ashLayer,BACKGROUND_FILL)
		pdb.plug_in_gmic_qt(image, layer_copy_a, 1, 0, 'samj_Pointillisme_B 1.0,16,100,1,0,1,0,0,0,255')
		pdb.plug_in_applylens(image, layer_copy_a, 1.8, FALSE, FALSE, TRUE)		
		lmer=pdb.gimp_image_merge_down(image, layer_copy_a,0)
		pdb.gimp_image_merge_down(image, lmer,0)
		pdb.plug_in_gauss(image,pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), 5, 5, 1)
		#pdb.gimp_selection_none(image)

	if create_pl==15:	# Drop Water
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_context_set_foreground(color1)		
		pdb.gimp_edit_fill(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"),FOREGROUND_FILL)		
		centered(image,pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
		pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), 1, 0, 'fx_drop_water 0,100,2.1,100,16384,9.12,159.84,10,1,0.5,0.25,0.5,0.75,0.05,0.15,0')
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
		pdb.gimp_selection_none(image)

	if create_pl==16:	# cloudy
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_context_set_foreground((0,0,0))	
		pdb.gimp_edit_fill(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"),FOREGROUND_FILL)		
		centered(image,pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
		pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), 1, 0, 'jeje_clouds 70.0,0.5')
		pdb.plug_in_gradmap(image, pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
		pdb.gimp_selection_none(image)

	if create_pl==17:	# camouflage
		camouflageLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Camouflage Planet", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, camouflageLayer, None,0)
		centered(image,camouflageLayer)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_context_set_foreground((0,0,0))	
		pdb.gimp_edit_fill(pdb.gimp_image_get_layer_by_name(image, "Camouflage Planet"),FOREGROUND_FILL)
			
		color_1=gmic_rgba_to_rgb(color1)
		color_2=gmic_rgba_to_rgb(color2)

		pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, "Camouflage Planet"), 1, 0, 'fx_camouflage 9,12,100,'+ str(color_1) + ','+ str(color_1) + ',' + str(color_2)+ ',' + str(color_2))

		hol = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, "Camouflage Planet"), image)
		pdb.gimp_image_insert_layer(image, hol, None, 0)

		pdb.gimp_drawable_desaturate(hol, 1)
		pdb.plug_in_bump_map(image, pdb.gimp_image_get_layer_by_name(image, "Camouflage Planet"), hol, 0, 45.0, 10, 0, 0, 0, 0, TRUE, FALSE, 0)
		pdb.plug_in_applylens(image, pdb.gimp_image_get_layer_by_name(image, "Camouflage Planet"), 1.8, FALSE, FALSE, TRUE)
		pdb.gimp_layer_set_mode(hol, LAYER_MODE_OVERLAY_LEGACY)
		x=pdb.gimp_image_merge_down(image, hol,0)	
		pdb.gimp_image_merge_down(image, x,0)
		
	if create_pl!=0 and (brightness !=0 or contrast !=0):	
		pdb.gimp_drawable_brightness_contrast(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), brightness, contrast)

		pdb.gimp_selection_none(image)

	if useCustomTexture and create_pl!=3:
		pdb.gimp_selection_none(image)
		texture = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Texture", 100.0,  LAYER_MODE_SOFTLIGHT_LEGACY)
		pdb.gimp_image_insert_layer(image, texture, None, 0)
		centered(image,texture)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)	
		pdb.gimp_context_set_pattern(customTexture)
		pdb.gimp_edit_fill(texture, FILL_PATTERN)
		pdb.plug_in_applylens(image, texture, 1.8, FALSE, FALSE, TRUE)
		pdb.plug_in_bump_map(image, pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), texture, 135.0, 45.0, 8, 0, 0, 0, 0, FALSE, FALSE, 1)	
		pdb.gimp_selection_none(image)				
	
#Planet color
	if changeColor==1:
		pdb.gimp_selection_none(image)
		planetColor = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Planet Color", 100, LAYER_MODE_LCH_HUE)
		pdb.gimp_image_insert_layer(image, planetColor, None, 0)
		centered(image, planetColor)
		pdb.gimp_context_set_foreground(planColor)
		pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
		pdb.gimp_edit_bucket_fill(planetColor, BUCKET_FILL_FG, LAYER_MODE_NORMAL_LEGACY, 100, 255, FALSE, 0, 0)
		planetColor = pdb.gimp_image_merge_down(image, planetColor, CLIP_TO_IMAGE)
		planetLayer = pdb.gimp_image_get_layer_by_name(image, "Planet")
		colorbrightness = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Color Brightness", 50, LAYER_MODE_ADDITION )
		pdb.gimp_image_insert_layer(image, colorbrightness, None, 0)
		centered(image, colorbrightness)
		pdb.gimp_drawable_fill(colorbrightness, FILL_TRANSPARENT)
		pdb.gimp_edit_bucket_fill(colorbrightness, BUCKET_FILL_FG, LAYER_MODE_NORMAL_LEGACY, 100, 255, FALSE, 0, 0)
		colorbrightness = pdb.gimp_image_merge_down(image, colorbrightness, CLIP_TO_IMAGE)
		planetLayer = pdb.gimp_image_get_layer_by_name(image, "Planet")
		
		pdb.gimp_image_select_item(image, 2, new_vectors_d)			
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(colorbrightness)
		pdb.gimp_selection_none(image)
	
	if icePole:    
		iceLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Planet Ice Poles", icePoleop, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_layer_add_alpha(iceLayer)
		pdb.gimp_image_insert_layer(image, iceLayer, None, 0)
		pdb.gimp_drawable_fill(iceLayer, FILL_TRANSPARENT)
		centered(image, iceLayer)
		wL = pdb.gimp_drawable_width(iceLayer)
		hL = pdb.gimp_drawable_height(iceLayer)

		x_coordinate=(wI-wL)/2
		y_coordinate=(hI-hL)/2

		pdb.gimp_image_select_rectangle(image, 2, x_coordinate, y_coordinate, r_planet*2, ice_thickness)
		pdb.gimp_context_set_foreground("White")	
		pdb.gimp_image_select_rectangle(image, 0, x_coordinate, y_coordinate+r_planet*2-ice_thickness, r_planet*2, ice_thickness)
		distrea(image,iceLayer,4,10,5,127)
		pdb.gimp_selection_none(image)  
		pdb.plug_in_gauss(image, iceLayer, 25, 25, 1)   #method=1
		pdb.plug_in_emboss(image, iceLayer, 90, 100, 10, FALSE)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)		
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(iceLayer)
		pdb.gimp_selection_none(image)
		ice_angle = ice_angle/180.0 * math.pi
		pdb.gimp_item_transform_rotate(pdb.gimp_image_get_layer_by_name(image, "Planet Ice Poles"), ice_angle, 1, 0, 0)	
		pdb.gimp_selection_none(image)		

	if  atmosphere==1:   
		atmosphere = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Luminance", 100, 0) #LAYER_MODE_SCREEN
		pdb.gimp_image_insert_layer(image, atmosphere, None, 0)
		centered(image,atmosphere)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)	
		pdb.gimp_context_set_foreground(color_atm)
		#pdb.gimp_selection_grow(image, atmoThickness)
		pdb.gimp_selection_border(image, atmoThickness)
		pdb.gimp_edit_fill(atmosphere, 0)
		pdb.gimp_selection_none(image)
		pdb.plug_in_gauss(image, atmosphere, atmoThickness,atmoThickness, 1)   #method=1
		#pdb.gimp_image_select_item(image, 2, new_vectors_d)			
		#pdb.gimp_edit_clear(atmosphere)
		pdb.gimp_layer_set_opacity( pdb.gimp_image_get_layer_by_name(image, "Luminance"),atmosphere_opacity)
		pdb.gimp_image_lower_item(image, pdb.gimp_image_get_layer_by_name(image, "Luminance"))		
		pdb.gimp_selection_none(image)

	#Lunar		
	if  moon==1:
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_drawable_desaturate(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), 4)
		pdb.gimp_selection_none(image)
		
	if addClouds==1:
	#Adding Cloud Layer
		cloudLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Clouds", 100.0, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, cloudLayer, None, 0)
		centered(image, cloudLayer)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)			
		pdb.gimp_edit_clear(cloudLayer)

	#Adding Clouds to cloudLayer using solid noise, color to alpha and set conrast
		pdb.plug_in_solid_noise(image, cloudLayer, 1, 1, random.randrange(1,999999999), 10, 5.0, 5.0)
		pdb.plug_in_colortoalpha(image, cloudLayer, (0,0,0))
		pdb.gimp_drawable_brightness_contrast(cloudLayer, -0.12, 0.04)
		
	#Map cloudLayer to Sphere, blur it and set contrast
		pdb.plug_in_gauss(image, cloudLayer, 15.0, 15.0, 1)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(cloudLayer)	
		pdb.gimp_selection_none(image)
		pdb.gimp_image_set_active_layer(image,cloudLayer)
		h,l,s = colorsys.rgb_to_hls(cloud_color[0]/255.0,cloud_color[1]/255.0,cloud_color[2]/255.0)
		hue = h * 360.0
		saturation = s * 100.0
		lightness = l * 200.0 - 100.0
		pdb.gimp_drawable_colorize_hsl(cloudLayer, hue, saturation, lightness)
		pdb.gimp_layer_set_opacity(cloudLayer,clouds_opacity)
		
	if lightning==1:
	
		lightLayer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Lightning", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, lightLayer, None, 0)
		pdb.gimp_image_set_active_layer(image,lightLayer)
		
		color_light_g=gmic_rgba_to_rgb(color_light)
		start_y_l=50-(r_planet*100)/hI
                                                                         
		pdb.plug_in_gmic_qt(image, lightLayer,1,0, 'fx_lightning 1024,42.6,1957,10.512,1.5,0.545,' + str(color_light_g)+',255,65535,50.0,' + str(start_y_l) +',-0.72,1,0.06,0,100,0,200,0,0,-1,-1,-1')
		pdb.gimp_image_remove_layer(image, pdb.gimp_image_get_layer_by_name(image, "Lightning #1"))
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Lightning"))
		pdb.gimp_selection_none(image)
	# Crescent Shadow
	if shadow_phases==1:

		crescent = pdb.gimp_layer_new(image, r_planet*2.1, r_planet*2.1, RGBA_IMAGE, "Crescent Shadow", 100, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, crescent, None, 0)
		centered(image, crescent)
		
		wL = pdb.gimp_drawable_width(crescent)
		hL = pdb.gimp_drawable_height(crescent)
		x_coordinate=(wI-wL)/2
		y_coordinate=(hI-hL)/2
		
		pdb.gimp_context_set_foreground("Black")
		pdb.gimp_image_select_ellipse(image, CHANNEL_OP_REPLACE, x_coordinate-r_planet, y_coordinate-r_planet, r_planet*3.1, r_planet*3.1)
		pdb.gimp_edit_bucket_fill(crescent, BUCKET_FILL_FG, LAYER_MODE_NORMAL_LEGACY, 100, 255, FALSE, 0, 0)     
		pdb.gimp_selection_none(image)
		pdb.plug_in_gauss(image, crescent, 100, 100, 1)   #method=1
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(crescent)
		pdb.gimp_selection_none(image)

		#Shadow angle
		sun_Angle=sun_Angle-45
		shadow_angle = sun_Angle/180.0 * math.pi
		pdb.gimp_item_transform_rotate(crescent, shadow_angle, True, 0, 0)       
  # Quarter Planet Shadow                  
	if shadow_phases==2:  
		firstQuarter = pdb.gimp_layer_new(image, r_planet*2.1, r_planet*2.1, RGBA_IMAGE, "Quarter Shadow", 100, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, firstQuarter, None, 0)			
		centered(image, firstQuarter)			

		wL = pdb.gimp_drawable_width(firstQuarter)
		hL = pdb.gimp_drawable_height(firstQuarter)
		x_coordinate=(wI-wL)/2
		y_coordinate=(hI-hL)/2			
		
		pdb.gimp_context_set_foreground("Black")
		pdb.gimp_image_select_rectangle(image, CHANNEL_OP_REPLACE, x_coordinate-r_planet/1.2, y_coordinate, r_planet*2.1, r_planet*2.1)	
		pdb.gimp_edit_bucket_fill(firstQuarter, BUCKET_FILL_FG, LAYER_MODE_NORMAL_LEGACY, 100, 255, FALSE, 0, 0)     
		pdb.gimp_selection_none(image)
		pdb.plug_in_gauss(image, firstQuarter, 100, 100, 1)   #method=1
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(firstQuarter)
		pdb.gimp_selection_none(image)

		#Shadow angle
		sunAngle = sun_Angle/180.0 * math.pi
		shadow_angle=sunAngle
		pdb.gimp_item_transform_rotate(firstQuarter,shadow_angle , True, 0, 0) 
		pdb.gimp_selection_none(image)
    # Waxing Gibbous Shadow
	if shadow_phases==3: 
		waxingGibbous = pdb.gimp_layer_new(image, r_planet*2.1, r_planet*2.1, RGBA_IMAGE, "Waxing Gibbous Shadow", 100, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_insert_layer(image, waxingGibbous, None, 0)
		centered(image, waxingGibbous)

		wL = pdb.gimp_drawable_width(waxingGibbous)
		hL = pdb.gimp_drawable_height(waxingGibbous)
		x_coordinate=(wI-wL)/2
		y_coordinate=(hI-hL)/2			

		pdb.gimp_layer_resize_to_image_size(waxingGibbous)     		
		pdb.gimp_context_set_foreground("Black")		
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_selection_grow(image, 50)
		pdb.gimp_edit_bucket_fill(waxingGibbous, BUCKET_FILL_FG, LAYER_MODE_NORMAL_LEGACY, 100, 255, FALSE, 0, 0)
		pdb.gimp_selection_none(image)
		pdb.gimp_image_select_ellipse(image, CHANNEL_OP_REPLACE, x_coordinate-r_planet*1.7, y_coordinate-r_planet/2, r_planet*3.1, r_planet*3.1)
		pdb.gimp_edit_clear(waxingGibbous)
		pdb.gimp_selection_none(image)
		pdb.plug_in_gauss(image, waxingGibbous, 75, 75, 1)   #method=1
		pdb.gimp_image_select_item(image, 2, new_vectors_d)		
		pdb.gimp_selection_invert(image)
		pdb.gimp_edit_clear(waxingGibbous)
		pdb.gimp_selection_none(image)

		sun_Angle=sun_Angle+180
		shadow_angle = sun_Angle/180.0 * math.pi
		pdb.gimp_item_transform_rotate(waxingGibbous, shadow_angle, True, 0, 0)
	
	color_to_gegl=rgb_to_hex(color_ls)
	
	if run_long_s==1:		
		shadow = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Shadow", 100, 0)
		pdb.gimp_image_insert_layer(image, shadow, None, -1)
		pdb.gimp_edit_fill(shadow, FILL_WHITE)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_drawable_edit_clear(shadow)
		pdb.gimp_selection_none(image)

		gegl_planet(image, shadow, "long-shadow style=fading-fixed-length angle=%d length=%d midpoint-rel=%f color=%s composition=shadow-minus-image" % (angle_ls, length_ls, midpoint_rel_ls, color_to_gegl))
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_selection_invert(image)		
		pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))		
		pdb.gimp_selection_none(image)
		
		if invert_color_ls:
			pdb.gimp_context_set_background(color_ls)
			pdb.gimp_image_select_item(image, 2, new_vectors_d)
			gegl_planet(image, shadow,"gegl-color-to-alpha color=%s" % (color_to_gegl))
			pdb.gimp_image_select_item(image, 2, shadow)
			pdb.gimp_drawable_edit_clear(shadow)
			pdb.gimp_selection_invert(image)
			pdb.gimp_edit_fill(shadow, 1)
			pdb.gimp_image_select_item(image, 2, new_vectors_d)
			pdb.gimp_selection_invert(image)
			pdb.gimp_drawable_edit_clear(shadow)
			pdb.gimp_selection_none(image)
			pdb.gimp_layer_set_opacity(shadow, color_ls_opacity)
	if crease==1 and what==1:
		pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), 1, 1,'fx_crease ' + str(amplitude_c)+ "," + str(frequency_c)+ "," + str(boundary))	
		pdb.gimp_item_set_name(image.layers[0]," Crease Planet")				
	if add_ring:
	
		pdb.gimp_selection_none(image)
		wL = pdb.gimp_drawable_width(layer)
		hL = pdb.gimp_drawable_height(layer)
		hI2=hI/2
		wI2=wI/2
		x_r=wI/2-r_planet - dist_r - border_radius/2
		y_r=hI/2-r_planet - dist_r - border_radius/2
		
		width_r=r_planet*2 + dist_r*2 + border_radius
		height_r=r_planet*2 + dist_r*2 + border_radius
		ringAngle = ring_Angle/180.0 * math.pi
		
		pdb.gimp_image_select_ellipse(image, 2, x_r, y_r, width_r, height_r)
		#pdb.plug_in_sel2path(image, layer)
		decrese_percent=(decrese)/100
		python_selection_to_gradient_border_pm(image, pdb.gimp_image_get_layer_by_name(image, "Ring"), border_radius/2, gradient)
		
		if remove_black:
			pdb.gimp_context_set_antialias(True)
			pdb.gimp_image_select_color(image, 2, pdb.gimp_image_get_layer_by_name(image, "Ring"), (0,0,0))
			pdb.gimp_selection_grow(image,grow)		
			pdb.gimp_edit_cut(pdb.gimp_image_get_layer_by_name(image, "Ring"))
			pdb.gimp_selection_none(image)		
		
		pdb.gimp_selection_none(image)
		pdb.gimp_layer_scale(pdb.gimp_image_get_layer_by_name(image, "Ring"), wL, hL*decrese_percent, 1)
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Ring"), "noise-spread amount-x=%d amount-y=%d" % (noise_spread, noise_spread))
		pdb.gimp_selection_none(image)


		
		if add_shad_ring==1 and shadow_phases!=0:
		
			shad_ring = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Shadow Ring", 90, 0)
			pdb.gimp_image_insert_layer(image, shad_ring,None, 1)
			pdb.gimp_image_select_ellipse(image, 2, x_r- border_radius/2, y_r- border_radius/2, width_r+ border_radius, height_r+ border_radius)
			pdb.gimp_image_select_polygon(image, 3, 10, (0,0,   0,hI,  wI2,hI,  wI2, 0,  0,0))
			pdb.gimp_context_set_foreground("Black")			
			pdb.gimp_edit_fill(shad_ring, 0)
			pdb.gimp_selection_none(image)
			pdb.gimp_layer_scale(pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"), wL+corect_x,r_planet*2*decrese_percent+corect_y, 1) #r_planet*1.7-dist_r*2		
			pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"))

			if shadow_phases==1:
				sun_Angle=sun_Angle+45+corect_angle
				shadow_angle = sun_Angle/180.0 * math.pi
			if shadow_phases==2:
				sun_Angle=sun_Angle+corect_angle
				shadow_angle = sun_Angle/180.0 * math.pi			
			if shadow_phases==3:
				sun_Angle=sun_Angle+180+corect_angle
				shadow_angle = sun_Angle/180.0 * math.pi
		
			pdb.gimp_selection_none(image)			

		pdb.gimp_item_transform_rotate(pdb.gimp_image_get_layer_by_name(image, "Ring"), ringAngle, 1, 0, 0)	
		pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Ring"))
		
		rx=math.tan(ringAngle)*wI2
		if create_pl!=0 and add_stargate==0:
			pdb.gimp_image_select_polygon(image, 0, 10, (0,0,   0,hI2-rx,  wI,hI2+rx,  wI, 0,  0,0))
			pdb.gimp_image_select_item(image, 3, new_vectors_d)
			pdb.gimp_selection_invert(image)
			pdb.gimp_selection_grow(image, 1)
			ring_channel = pdb.gimp_selection_save(image)
			layermask=pdb.gimp_layer_create_mask(pdb.gimp_image_get_layer_by_name(image, "Ring"), 4)
			pdb.gimp_layer_add_mask(pdb.gimp_image_get_layer_by_name(image, "Ring"), layermask)
		pdb.gimp_selection_none(image)

		if add_shad_ring==1 and shadow_phases!=0:
			pdb.gimp_item_transform_rotate(pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"), shadow_angle, 1, 0, 0)
			if burn==0:
				pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Ring"))
				pdb.gimp_context_set_sample_transparent(True)
				pdb.gimp_image_select_contiguous_color(image, 2, pdb.gimp_image_get_layer_by_name(image, "Ring"), wI2, hI2)
				pdb.gimp_selection_invert(image)
				pdb.gimp_image_select_item(image, 3, pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"))
				pdb.gimp_selection_invert(image)
				pdb.gimp_drawable_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"))
				pdb.gimp_selection_none(image)
				pdb.gimp_image_raise_layer(image, pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"))
				if add_stargate==0:
					pdb.gimp_image_select_item(image, 2, ring_channel)
					layermask_r=pdb.gimp_layer_create_mask(pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"), 4)
					pdb.gimp_layer_add_mask(pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"), layermask_r)
				
		pdb.gimp_selection_none(image)		
	if burn==1 and add_ring==1:
	
		pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Ring"))
		pdb.gimp_context_set_sample_transparent(True)
		pdb.gimp_image_select_contiguous_color(image, 2, pdb.gimp_image_get_layer_by_name(image, "Ring"), wI2, hI2)
		pdb.gimp_selection_invert(image)
		pdb.gimp_selection_grow(image, 4)
		pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, "Ring"), 1, 0, 'gui_rep_frblur 6,10,5,0,0,1,0,0,50,50')
		pdb.plug_in_gauss(image, pdb.gimp_image_get_layer_by_name(image, "Ring"), 3,3, 1)
		
		if add_ring==1 and add_shad_ring==0:
			pdb.gimp_image_select_item(image, 2, new_vectors_d)
			pdb.gimp_selection_invert(image)
			pdb.gimp_image_select_item(image, 3, pdb.gimp_image_get_layer_by_name(image, "Ring"))
			pdb.gimp_selection_invert(image)

		if add_ring==1 and add_shad_ring==1:
			pdb.gimp_image_select_item(image, 2, new_vectors_d)
			pdb.gimp_selection_invert(image)
			pdb.gimp_image_select_item(image, 3, pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"))
			pdb.gimp_selection_invert(image)
			pdb.gimp_drawable_edit_clear(pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"))
			pdb.gimp_selection_none(image)
			pdb.gimp_image_raise_layer(image, pdb.gimp_image_get_layer_by_name(image, "Shadow Ring"))		
		pdb.gimp_selection_none(image)
		
	if add_stargate==1 and add_ring==1 and add_shad_ring==0:
		pdb.gimp_selection_none(image)
		pdb.gimp_context_set_sample_transparent(True)
		pdb.gimp_image_select_contiguous_color(image, 2, pdb.gimp_image_get_layer_by_name(image, "Ring"), 1, 1)
		pdb.gimp_selection_invert(image)
		pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Ring"))
		pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, "Ring"), 1, 1,'fractalize 0.8')
		pdb.gimp_item_set_name(pdb.gimp_image_get_layer_by_name(image, "Ring #1"), "Stargate")
		pdb.gimp_layer_set_mode(pdb.gimp_image_get_layer_by_name(image, "Stargate"),LAYER_MODE_DIFFERENCE_LEGACY)  #LAYER_MODE_HARDLIGHT_LEGACY ? , LAYER_MODE_GRAIN_EXTRACT_LEGACY ??
		if stargate_motion:
			pdb.gimp_selection_none(image)
			pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Stargate"))
			stargate_m = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, "Stargate"), image)
			pdb.gimp_image_insert_layer(image, stargate_m, None, -1)
			pdb.gimp_item_set_name(stargate_m, "Motion Stargate")
			#pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, "Motion Stargate"))
			gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Motion Stargate"),"motion-blur-zoom center-x=0.5 center-y=0.5 factor=0.6")
			
		
	if super_nova:			
		super_nova = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Super Nova", 100, 0)
		pdb.gimp_image_insert_layer(image, super_nova, None, -1)
		color_sn_to_gegl=rgb_to_hex(color_sn)		
		gegl_planet(image, super_nova, "supernova center-x=%f center-y=%f radius=%d spokes-count=%d color=%s" % (center_xs, center_ys, radius_x, spokes_count, color_sn_to_gegl))
		pdb.gimp_image_raise_item_to_top(image, super_nova)
		
	if lens_flare:
	
		sunLayer = pdb.gimp_layer_new(image, image.width, image.height, RGB_IMAGE, "Sun and flare", 100, LAYER_MODE_SCREEN)
		pdb.gimp_image_insert_layer(image, sunLayer,None, 1)
		pdb.gimp_context_set_foreground((0, 0, 0))
		pdb.gimp_drawable_fill(sunLayer, FILL_FOREGROUND)
		pdb.plug_in_flarefx(image, sunLayer, x_pos, y_pos)
		
	pdb.gimp_selection_none(image)
	
	if fr_ship:
		pdb.gimp_selection_none(image)
		if size_ship==0:
			add_frship=gimp.Layer(image, "Fractaloid", wI,hI, RGBA_IMAGE, 100, 0)		
		else:
			add_frship=gimp.Layer(image, "Fractaloid", int(hI*size_ship/100),int(hI*size_ship/100), RGBA_IMAGE, 100, 0)
		pdb.gimp_image_insert_layer(image, add_frship, None, -1)

		if fr_ship==1:		
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_rep_pfrac_t_rs 50,1,0.05,3,0.5,45,50,50,0,0,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0,0.5,0,0')	
		if fr_ship==2:		
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_rep_pfrac_t_rs 50,1,0.22,-2.85,0.496,45,50,50,0,0,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0,0.5,0,0')
		if fr_ship==3:	
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_rep_pfrac_t_rs 50,1,-0.15,1.5,0.5,45,50,50,0,1,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0.2,0.5,0,0')
		if fr_ship==4:		
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_rep_pfrac_t_rs 50,1,-0.05,-4.5,0.5,45,50,50,0,1,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0.2,0.5,0,0')		
		if fr_ship==5:			
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_rep_pfrac_t_rs 45,1,-0.05,-4.5,0.406,45,50,50,0,1,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0,0.5,0,0')
		if fr_ship==6:			
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_rep_pfrac_t_rs 45,1,0.17,2.55,0.437,45,50,50,0,0,1,2,0,1,0,5,5,1,2,5,1,0,5,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0,0.5,0,0')
		if fr_ship==7:			
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_rep_pfrac_t_rs 50,1,-0.75,2,0.5,45,50,50,0,1,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0,0.5,0,0')		
		if fr_ship==8:	
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_rep_pfrac_t_rs 50,1,0.75,1.5,0.5,45,50,50,0,1,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0,0.5,0,0')		
		if fr_ship==9:
			pdb.plug_in_gmic_qt(image, add_frship, 1, 0, str(preset))
	
	
		centered(image,add_frship)
		pdb.gimp_image_crop(image, wI, hI, 0,0)			
		pdb.gimp_context_set_feather(True)
		pdb.gimp_context_set_feather_radius(1,1)
		pdb.gimp_context_set_antialias(True)
		pdb.gimp_context_set_sample_criterion(0)
		pdb.gimp_image_select_color(image, 2, add_frship, (0,0,0))

		pdb.gimp_edit_clear(add_frship)
		pdb.gimp_selection_none(image)
		
		if what==2 and d_block==1 and size_ship!=0:
			c,d = pdb.gimp_drawable_offsets(add_frship)
			pdb.gimp_image_set_active_layer(image,add_frship)
			pdb.gimp_layer_set_offsets(add_frship, c, 0)
			
		pdb.gimp_image_set_active_layer(image,add_frship)
		pdb.plug_in_gmic_qt(image, add_frship, 1, 0, 'fx_smooth_anisotropic 60,0.7,0.3,0.6,1.1,0.8,30,2,0,1,1,0,0,50,50')
		
		
		if beautify!=0 and fr_ship!=0:
			pdb.gimp_selection_none(image)
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Fractaloid"))	
			reg_layer = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Beautify Ship", 100, LAYER_MODE_NORMAL)
			pdb.gimp_image_insert_layer(image, reg_layer, None, -1)		
				
			if beautify==1:   #gradient:
				pdb.gimp_edit_blend(reg_layer, 3, 0, 0, 100, 0, 0, 0, 0, 1, 4, 0, wI/2, 0, wI/2, hI,)
				pdb.gimp_layer_set_mode(reg_layer, LAYER_MODE_OVERLAY_LEGACY)
				add_frship=pdb.gimp_image_merge_down(image, reg_layer, 0)
				
			if beautify==2:   #plasma:
				pdb.gimp_image_set_active_layer(image,reg_layer)
				pdb.plug_in_gmic_qt(image, reg_layer, 1, 0, 'fx_plasma 0.5,0,8,1,0,128,128,128')
				reg_layer_2 = pdb.gimp_layer_new_from_drawable(reg_layer, image)
				pdb.gimp_image_insert_layer(image, reg_layer_2, None, -1)
				pdb.gimp_item_transform_flip_simple (reg_layer_2, 0, True, 0)
				pdb.gimp_image_select_polygon(image, 0, 10,(0,0, wI/2,0, wI/2,hI, 0,hI, 0,0))
				pdb.gimp_edit_clear (reg_layer_2)
				pdb.gimp_selection_none(image)
				layer_b = pdb.gimp_image_merge_down(image, reg_layer_2, 0)
				pdb.gimp_layer_set_mode(layer_b, LAYER_MODE_OVERLAY_LEGACY)
				add_frship=pdb.gimp_image_merge_down(image, layer_b, 0)
				
		if polarize:
			gegl_planet(image, add_frship, "polar-coordinates depth=100 angle=%d middle=1" % (angle_f))
		if colorize:
			pdb.plug_in_colorify(image, add_frship, color_ship)			
		if neonize:
			gegl_planet(image, add_frship, "edge-neon radius=%f amount=%f" % (radius_neon, amount_neon))			
		if emboss:
			gegl_planet(image, add_frship,'emboss type=bumpmap azimuth=120 elevation=80 depth=5')
			
		pdb.gimp_image_raise_item_to_top(image, pdb.gimp_image_get_layer_by_name(image, "Fractaloid"))
		
	pdb.gimp_selection_none(image)		
	
	if ship:
	
		colorships = gmic_rgba_to_rgb(color_ship)
		if size_space==0:
			spaceships = pdb.gimp_layer_new(image, image.width, image.height, RGB_IMAGE, "Space Ships", 100, LAYER_MODE_NORMAL)		
		else:
			spaceships=gimp.Layer(image, "Space Ships", int(hI*size_space/100),int(hI*size_space/100), RGBA_IMAGE, 100, 0)
		pdb.gimp_image_insert_layer(image, spaceships, None, 0)
		centered(image,spaceships)
		if ship==1:
		# torus
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 4,' + str(colorships)+',255,0.675,0.492,2.124,44.64,39.96,19.44,90,-100,100,0,0.399,1.056,3,1')
		
		if ship==2:			
		# flying saucer 1
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 7,' + str(colorships)+',255,0.5,0.321,3,133.92,106.2,286.2,17.999,0.6,0,-82.2,0,0,3,1')
		
		if ship==3:			
		# flying saucer 2			
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 7,0,85,255,255,0.5,0.12,1.128,14.4,109.8,231.84,17.999,0.6,0,-29.5,0,0,5,1')

		if ship==4:				
		# gyroid 1
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 5,' + str(colorships)+',255,0.5,0.141,0.141,25.2,49.68,203.04,90,48.4,-35.6,-27.5,0.641,0.7,5,1')
			
		if ship==5:				
		# gyroid 2
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 5,' + str(colorships)+',255,0.5,0.168,0.918,168.84,132.84,146.16,90,0,0,-100,0.5,0.7,5,1')
		
		if ship==6:
		# Arrowhead
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 2,' + str(colorships)+',255,0.5,0.282,0.957,89.28,123.12,47.16,9.989,0,5.4,-22.8,0.453,0.384,3,1')
		
		if ship==7:
		# Weird 1
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 6,' + str(colorships)+',255,0.5,0.993,0.489,180,27,245.16,90,-18.8,16.2,-92.5,0.375,0.789,4,1')		
		
		if ship==8:
		# Weird 2
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 6,' + str(colorships)+',255,0.5,0.714,0.207,0,0,67.68,90,1.2,3.8,-53.7,0.256,0.264,4,1')
		
		if ship==9:		# Elipsoid
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_coloredobject3d 3,' + str(colorships)+',255,0.6,0.654,3,201.24,69.48,219.24,1,15.6,5.4,-22.8,0.282,0.912,3,1')
		
		pdb.gimp_layer_add_alpha(spaceships)
		pdb.gimp_context_set_antialias(True)
		pdb.gimp_context_set_sample_threshold_int(2) # 0-255
		pdb.gimp_context_set_sample_criterion(0) # SELECT-CRITERION-COMPOSITE
		pdb.gimp_image_select_contiguous_color(image, 0, spaceships, 1, 1)
		pdb.gimp_edit_clear(spaceships)
		if ship==1:
			pdb.gimp_selection_none(image)
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Space Ships"))
			pdb.gimp_context_set_sample_transparent(FALSE)
			pdb.gimp_context_set_sample_merged(TRUE)
			pdb.gimp_image_select_contiguous_color(image, 2, spaceships, float(wI/2), float(hI/2))
		pdb.gimp_edit_clear(spaceships)
		pdb.gimp_selection_none(image)
	
		if ship==3:
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Space Ships"))
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_ghost 65,1.68,0,0.012,0.75,64,0,0,50,50')
			gegl_planet(image, spaceships, 'wind style=wind direction=bottom edge=leading threshold=25 strength=50')
		
		if ship==6:
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Space Ships"))
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_ghost 464,3.3,8.22,-0.138,3,16,0,0,50,50')
			pdb.plug_in_gmic_qt(image, spaceships, 1, 0, 'fx_ghost 464,3.3,8.22,-0.138,3,16,0,0,50,50')
		
		if colorize:
			pdb.plug_in_colorify(image, spaceships, color_ship)
		if neonize:
			gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Space Ships"), "edge-neon radius=%f amount=%f" % (radius_neon, amount_neon))
		if emboss:
			gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Space Ships"),'emboss type=bumpmap azimuth=120 elevation=80 depth=5')	
		
		pdb.gimp_image_raise_item_to_top(image, pdb.gimp_image_get_layer_by_name(image, "Fractaloid"))				
			
		pdb.gimp_image_raise_item_to_top(image, pdb.gimp_image_get_layer_by_name(image, "Space Ships"))
	
	if famous_ships!=0:

		if famous_ships==1:
			famousships="Famous Spaceships"
		if famous_ships==2:
			famousships="Famous Spaceships 2"
		if famous_ships==3:
			famousships="Star Navy"	
			
		pdb.gimp_context_set_foreground((255, 255, 255))
		famous = pdb.gimp_layer_new(image, image.width, image.height, RGBA_IMAGE, "Famous Ships", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, famous, None, -1)		
		text_famous_ships = pdb.gimp_text_fontname(image, None, 0, 0, text, 0, 1, size_text, 0, famousships)
		pdb.plug_in_autocrop_layer(image, text_famous_ships)
		centered(image,text_famous_ships)

		text_famous=pdb.gimp_image_merge_down(image, text_famous_ships, 0)
		pdb.gimp_layer_resize_to_image_size(text_famous)		
		pdb.gimp_image_select_item(image, 2, text_famous)
		pdb.gimp_selection_grow(image, 1)
		gegl_planet(image, text_famous,'distance-transform')
		pdb.gimp_selection_shrink(image, 1)
		pdb.gimp_image_raise_item_to_top(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships"))
		
		if pixelize==1:
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Famous Ships"))  
			pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), 1, 1, 'fx_superpixels ' + str(size_pix)+ ',0,10,1,1,0,0,0,255,0,50,50')
			pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Famous Ships #1"))
			pdb.gimp_selection_none(image)
			pdb.plug_in_gauss(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships #1"), 2, 2, 1) 
			pdb.plug_in_bump_map(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships"),pdb.gimp_image_get_layer_by_name(image, "Famous Ships #1"),  135.0, 45.0, 3, 0, 0, 0, 0, TRUE, 0, 1)
			pdb.gimp_image_raise_item_to_top(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships #1"))		
			pdb.gimp_image_remove_layer(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships #1"))
			pdb.gimp_selection_none(image)
			
		if pixelize==2:	
		
			#pdb.gimp_context_set_foreground((255,255,255))
			#pdb.gimp_context_set_background((255,255,255))
			pdb.gimp_selection_none(image)
			ms = pdb.gimp_layer_new(image, wI, hI, RGB_IMAGE, "ministeck", 90, LAYER_MODE_HARDLIGHT)
			pdb.gimp_image_insert_layer(image, ms, None,-1)
			pdb.gimp_layer_add_alpha(pdb.gimp_image_get_layer_by_name(image, "ministeck"))
			pdb.gimp_image_set_active_layer(image,ms)
			pix=int(size_pix)
			pdb.gimp_image_set_active_layer(image,ms)
			pdb.plug_in_gmic_qt(image,ms, 1, 0,'fx_ministeck 8,256,' + str(pix)+ ',2,100,0.3,1')  #fx_ministeck fx_ministeck 8,64,16,2,100,0.3,1
			pdb.gimp_image_crop(image, wI, hI, 0, 0)
			pdb.gimp_image_select_item(image,0,pdb.gimp_image_get_layer_by_name(image, "Famous Ships"))
			pdb.gimp_selection_invert(image)
			#pdb.gimp_layer_add_alpha(pdb.gimp_image_get_layer_by_name(image, "ministeck"))			
			pdb.gimp_drawable_edit_clear(pdb.gimp_image_get_layer_by_name(image, "ministeck"))
			pdb.gimp_selection_none(image)
			text_famous=pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "ministeck"), 0)
			#pdb.gimp_image_get_layer_by_name(image, "Famous Ships")=mini_steck	
			
		if pixelize==3 or pixelize==4 :		
			pdb.gimp_selection_none(image)
			ms = pdb.gimp_layer_new(image, wI, hI, RGB_IMAGE, "ministeck", 90, LAYER_MODE_HARDLIGHT)
			pdb.gimp_image_insert_layer(image, ms, None,-1)
			pdb.gimp_layer_add_alpha(pdb.gimp_image_get_layer_by_name(image, "ministeck"))
			pdb.gimp_image_set_active_layer(image,ms)
			pix=int(size_pix)
			pdb.gimp_image_set_active_layer(image,ms)
			if pixelize==3:
				pdb.plug_in_gmic_qt(image,ms, 1, 0,'fx_truchet ' +str(pix)+ ',4,0.1,0,3') #fx_ministeck 8,64,' + str(pix)+ ',2,100,0.3,1')  #fx_ministeck fx_ministeck 8,64,16,2,100,0.3,1
			if pixelize==4:  # Curved
				pdb.plug_in_gmic_qt(image,ms, 1, 0,'fx_truchet ' +str(pix)+ ',4,0.1,1,3')			
			
			pdb.gimp_image_crop(image, wI, hI, 0, 0)
			pdb.gimp_image_select_item(image,0,pdb.gimp_image_get_layer_by_name(image, "Famous Ships"))
			pdb.gimp_selection_invert(image)
			#pdb.gimp_layer_add_alpha(pdb.gimp_image_get_layer_by_name(image, "ministeck"))			
			pdb.gimp_drawable_edit_clear(pdb.gimp_image_get_layer_by_name(image, "ministeck"))
			pdb.gimp_selection_none(image)
			text_famous=pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "ministeck"), 0)		

			pdb.gimp_selection_none(image)			
		if pixelize==5:	# Grid Triangular
			grid_x=8+int(size_pix)	
			grid_y=8+int(size_pix)
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Famous Ships")) 
			pdb.plug_in_gmic_qt(image,pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), 1, 0,"fx_imagegrid_triangular "+str(grid_x)+","+ str(grid_y)+",2,255,255,255,128")
			

		if pixelize==6:	# pills			
			pix=34 - int(size_pix)/3
			pdb.plug_in_gmic_qt(image,pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), 1, 0,'fx_pills ' + '0,' +str(pix)+ ',45.00,4,0,4,0,4,0')

		if pixelize==7:	# boxfitting
			pix=int(size_pix)/3
			pdb.plug_in_gmic_qt(image,pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), 1, 0,'fx_boxfitting ' +str(pix)+ ',0,0.25,2,0')
			
		if pixelize==8:	# 
			pdb.gimp_selection_none(image)
			x=pdb.gimp_context_get_pattern()
			width, height, bpp = pdb.gimp_pattern_get_info(x)
			temp_layer = pdb.gimp_layer_new(image,width,height, 1, "New pattern", 100, 0)	
			pdb.gimp_image_insert_layer(image, temp_layer, None, -1)
			pdb.gimp_drawable_fill(temp_layer, 4)
			
			pdb.gimp_layer_scale(temp_layer, temp_layer.width*size_pix/100, temp_layer.height*size_pix/100, 1)		

			pdb.gimp_edit_copy(temp_layer)
			pdb.gimp_context_set_pattern(pdb.gimp_patterns_list('')[1][0])
			pdb.gimp_layer_set_lock_alpha(pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), 1)
			pdb.gimp_drawable_edit_fill(pdb.gimp_image_get_layer_by_name(image, "Famous Ships"),FILL_PATTERN)
			pdb.gimp_layer_set_lock_alpha(pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), 0)
			image.clean_all()
			#pdb.gimp_image_raise_item_to_top(image, layer)
			pdb.gimp_image_remove_layer(image, temp_layer)
			pdb.gimp_context_set_pattern(x)
	

			#pdb.gimp_edit_fill(pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), FILL_PATTERN)

			
		if colorize:
			pdb.plug_in_colorify(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), color_ship)
			
		if neonize:
			gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), "edge-neon radius=%f amount=%f" % (radius_neon, amount_neon))
			
		if emboss:
			gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Famous Ships"),'emboss type=bumpmap azimuth=120 elevation=80 depth=5')
		
		pdb.gimp_selection_none(image)		
		pdb.gimp_item_transform_rotate(pdb.gimp_image_get_layer_by_name(image, "Famous Ships"), angle_fs*0.01745329252 ,FALSE, wI/2, hI/2)
		if angle_fs!=0:
			pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Famous Ships"))
		
	if meteorize and run_stars_gmic==1:
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Stars Gmic"), 'motion-blur-linear length=%f angle=%f' % (length_m, angle_m))
		if spiralize_met:
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Stars Gmic"))
			pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, "Stars Gmic"), 1, 0, 'gui_rep_sd 1,1,0,0,0,0,50,50,0,50,50,1,50,50,100,100,3,4,0,50,21')
		
	if comet and create_pl!=0:
		if create_pl!=5:
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
			lavaLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Lava Planet", 100, LAYER_MODE_NORMAL)
			pdb.gimp_image_insert_layer(image, lavaLayer, None,-1)
			centered(image,lavaLayer)
			pdb.gimp_context_set_gradient("Incandescent")
			pdb.gimp_blend(lavaLayer,BLEND_CUSTOM,LAYER_MODE_NORMAL,GRADIENT_RADIAL ,100,0,REPEAT_NONE,False,False,3,0.2,True,lavaLayer.width/2,lavaLayer.height/2,lavaLayer.width/2,lavaLayer.height)
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Lava Planet"))			
			pdb.plug_in_gmic_qt(image, lavaLayer, 1, 0, 'fx_lava 15,20,3,0,0,50,50')
			pdb.plug_in_gmic_qt(image, lavaLayer, 1, 0, 'deform 30')
			pdb.plug_in_gauss(image, lavaLayer, 2, 2, 1)
			pdb.plug_in_emboss(image, lavaLayer, 90, 100, 7, False)		
			pdb.plug_in_map_object(image, lavaLayer, 1, 0.5, 0.5, 1.7, 0.5, 0.5, 0.9, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, \
			0.0, 0.0, 0.0, 2, (255,255,255), -0.5, -0.5, 2, -1.0, -1.0, 1.0, 0.30, 1, 0.5, 0.3, 27, \
			TRUE, FALSE, FALSE, TRUE, 0.225, 1, 1, 1, 1, lavaLayer, lavaLayer, lavaLayer, lavaLayer, lavaLayer, lavaLayer, lavaLayer, lavaLayer)		
			pdb.gimp_layer_set_opacity(pdb.gimp_image_get_layer_by_name(image, "Lava Planet"), 50)
			pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Lava Planet"), 0)
			
		pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, "Planet Sources"))
		layer_copy_sp = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), image)
		pdb.gimp_image_insert_layer(image, layer_copy_sp, None,0)		
		pdb.plug_in_gmic_qt(image,image.layers[0], 1, 0, "samj_Random_Small_Deformations 15,5,1")
		pdb.gimp_item_set_name(image.layers[0], "Comet Planet")

		centered(image,pdb.gimp_image_get_layer_by_name(image, "Comet Planet"))
		layer_copy_cp = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, "Comet Planet"), image)
		pdb.gimp_image_insert_layer(image, layer_copy_cp, None,0)			
		pdb.gimp_item_set_name(image.layers[0], "Tail of Comet")		

		pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Tail of Comet"))
		cent=0.50- r_planet/image.width - 0.01
		factor_comet=factor_c/100
		pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, "Tail of Comet"))
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Tail of Comet"),"supernova center-x=%f center-y=0.5 radius=20 spokes-count=100 color=#c8c819" % (cent))
		pdb.gimp_selection_none(image)
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Tail of Comet"),"motion-blur-zoom center-x=0.25 center-y=0.5 factor=%f" % (factor_comet))
		
		
		angle = angle_t/180.0 * math.pi
		item = pdb.gimp_item_transform_rotate(pdb.gimp_image_get_layer_by_name(image, "Tail of Comet"),angle,True,0,0)
		if pdb.gimp_layer_is_floating_sel(item):
			pdb.gimp_floating_sel_anchor(item)
			
		pdb.gimp_layer_set_opacity(pdb.gimp_image_get_layer_by_name(image, "Tail of Comet"),opacity_t)
		pdb.gimp_item_set_visible(pdb.gimp_image_get_layer_by_name(image, "Planet Sources"), 0)
		pdb.gimp_image_merge_down(image, pdb.gimp_image_get_layer_by_name(image, "Tail of Comet"), 0)		
		#pdb.gimp_image_lower_item(image, pdb.gimp_image_get_layer_by_name(image, "Tail of Comet"))
		
	if explode !=0:	# "Planet"),_("Comet Planet"), _("Fractal Ship"),_("Space Ship"), _("Famous Ships")
	
		if explode==1 and create_pl!=0:
			exp="Planet Sources"
		if explode==2 and create_pl!=0 and comet==1:
			exp="Comet Planet"
		if explode==3 and fr_ship!=0:
			exp="Fractaloid"
		if explode==4 and ship!=0:		
			exp="Space Ships"
		if explode==5 and famous_ships!=0:		
			exp="Famous Ships"
			
		if duplicate==1:	
			layer_copy_s = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, exp), image)
			pdb.gimp_image_insert_layer(image, layer_copy_s, None,-1)
			pdb.gimp_item_set_visible(layer_copy_s, 0)
			#pdb.gimp_image_lower_item(image, layer_copy_s)
		
		pdb.gimp_image_select_item(image, 2, pdb.gimp_image_get_layer_by_name(image, exp))
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, exp), 'mosaic tile-type=octagons tile-size=%f tile-height=10.0 tile-neatness=0.5 color-variation=0 color-averaging=0 tile-surface=0 tile-allow-split=0 tile-spacing=%f antialiasing=1' % (tile_size, tile_spacing))
		pdb.gimp_image_select_color(image, 2, pdb.gimp_image_get_layer_by_name(image, exp), (0,0,0))
		pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, exp))
		pdb.gimp_selection_none(image)
		pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, exp))	
		pdb.plug_in_gmic_qt(image,pdb.gimp_image_get_layer_by_name(image, exp), 1, 0, "fx_zoom 1.5,50,50,0")
		pdb.plug_in_gmic_qt(image,pdb.gimp_image_get_layer_by_name(image, exp), 1, 0, "fx_breaks 0,32.7,35.4,1.93,3")		
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, exp),"motion-blur-zoom center-x=0.5 center-y=0.5 factor=%f" % (object_spred))
		pdb.gimp_selection_none(image)

		pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, exp))		
		fireLayer = pdb.gimp_layer_new(image, r_planet*2, r_planet*2, RGBA_IMAGE, "Fire", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_insert_layer(image, fireLayer, None,-1)
		centered(image,fireLayer)
		pdb.gimp_image_select_item(image, 2, new_vectors_d)
		pdb.gimp_context_set_foreground(color_out)
		pdb.gimp_drawable_edit_fill(fireLayer, FILL_FOREGROUND)
		pdb.gimp_selection_shrink(image, r_planet/2)
		pdb.gimp_context_set_foreground(color_in)
		pdb.gimp_drawable_edit_fill(fireLayer, FILL_FOREGROUND)
		pdb.gimp_selection_none(image)
		pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, "Fire"))
		hex_out = gmic_rgba_to_rgb(color_out)
		hex_in = gmic_rgba_to_rgb(color_in)

		pdb.plug_in_gmic_qt(image,pdb.gimp_image_get_layer_by_name(image, "Fire"), 1, 0,"fx_stars 200,5,20,16,1,3," + str(hex_in) + ",200")
		pdb.plug_in_gmic_qt(image,pdb.gimp_image_get_layer_by_name(image, "Fire"), 1, 0,"fx_stars 150,5,20,16,1,3," + str(hex_out) + ",200")
		pdb.plug_in_gmic_qt(image,pdb.gimp_image_get_layer_by_name(image, "Fire"), 1, 0, "fx_breaks 1,80,75,2,0")
		gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, "Fire"),"motion-blur-zoom center-x=0.5 center-y=0.5 factor=%f" % (fire_spred)) #0.5
		pdb.gimp_image_lower_item(image, pdb.gimp_image_get_layer_by_name(image, "Fire"))
		
	if what!=0:
	
		if what==1 and create_pl!=0:
			elev="Planet Sources"	
		if what==2 and create_pl!=0 and comet==1:
			elev="Comet Planet"			
		if what==3 and fr_ship!=0:
			elev="Fractaloid"
		if what==4 and ship!=0:		
			elev="Space Ships"
		if what==5 and famous_ships!=0:		
			elev="Famous Ships"	
			
		pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, elev))
		pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, elev))
		
		if amplitude_random_deform!=0:
			pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, elev), 1, 0, 'deform ' + str(amplitude_random_deform))
			
		if d_block or extrude or elevation:
			layer_copy_org = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, elev), image)
			pdb.gimp_image_insert_layer(image, layer_copy_org, None,1)
			pdb.gimp_item_set_visible(layer_copy_org, 0)
			pdb.gimp_item_set_name(pdb.gimp_image_get_layer_by_name(image, pdb.gimp_item_get_name(layer_copy_org)), elev+" Org")
		
		if d_block:
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, elev))
			pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, elev), 1, 0, 'fx_blocks3d ' +str(resolution)+',4,' + str(elevation_b)+',3,'+ str(angle_block)+ ',60,45,50,50,0,0,-20.1,0.5,0.7,1,1,0,0,0,128')
			pdb.plug_in_autocrop_layer(image, pdb.gimp_image_get_layer_by_name(image, elev))
			
			a,b = pdb.gimp_drawable_offsets(pdb.gimp_image_get_layer_by_name(image, elev))
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, elev))
			wL = pdb.gimp_drawable_width(pdb.gimp_image_get_layer_by_name(image, elev))
			hL = pdb.gimp_drawable_height(pdb.gimp_image_get_layer_by_name(image, elev))
			off= (hI-hL)/2
			pdb.gimp_layer_set_offsets(pdb.gimp_image_get_layer_by_name(image, elev), a, off)
			
			
			#centered(image, pdb.gimp_image_get_layer_by_name(image, elev))
			pdb.gimp_image_crop(image, wI, hI, 0,0)
			pdb.gimp_layer_resize_to_image_size(pdb.gimp_image_get_layer_by_name(image, elev))
			if extrude or elevation:
				layer_copy_e = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, elev), image)
				pdb.gimp_image_insert_layer(image, layer_copy_e, None,1)
				pdb.gimp_item_set_visible(layer_copy_e, 0)
				pdb.gimp_item_set_name(pdb.gimp_image_get_layer_by_name(image, pdb.gimp_item_get_name(layer_copy_e)), elev+" 3D Block")
		if extrude:
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, elev))
			pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, elev), 1, 0, 'fx_extrude3d 96.14,1024,0.6,'+ str(wI) +','+ str(hI)+ ',0.447,334.8,37.44,'+ str(angle_extr)+ ',90,-43.8,-24.2,-91.3,0.056,0.051,5,1,0')		
			if gradmap:
				pdb.plug_in_gradmap(image, pdb.gimp_image_get_layer_by_name(image, elev))
			if alien_map:
				gegl_planet(image, pdb.gimp_image_get_layer_by_name(image, elev), "alien-map cpn-3-keep=1")		
			if elevation:
				layer_copy_extrude = pdb.gimp_layer_new_from_drawable(pdb.gimp_image_get_layer_by_name(image, elev), image)
				pdb.gimp_image_insert_layer(image, layer_copy_extrude, None,1)
				pdb.gimp_item_set_visible(layer_copy_extrude, 0)
				pdb.gimp_item_set_name(pdb.gimp_image_get_layer_by_name(image, pdb.gimp_item_get_name(layer_copy_extrude)), elev+" 3D Extrude")				
		if elevation:
			pdb.gimp_image_set_active_layer(image,pdb.gimp_image_get_layer_by_name(image, elev))
			pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, elev), 1, 0, 'fx_elevation3d 472,1,'+ str(wI) +','+ str(hI)+ ',1.0,360,360,'+ str(angle_elev)+ ',90,-6.8,-0.6,0,0.01,0.447,3,1,0')
			pdb.gimp_context_set_background((0,0,0))
			pdb.gimp_layer_flatten(pdb.gimp_image_get_layer_by_name(image, elev))
			pdb.gimp_layer_add_alpha(pdb.gimp_image_get_layer_by_name(image, elev))
			pdb.gimp_context_set_antialias(True)
			pdb.gimp_context_set_sample_criterion(0)
			pdb.gimp_image_select_contiguous_color(image, 2, pdb.gimp_image_get_layer_by_name(image, elev), 1, 1)
			pdb.gimp_context_set_sample_threshold_int(0)
			pdb.gimp_edit_clear(pdb.gimp_image_get_layer_by_name(image, elev))
			pdb.gimp_selection_none(image)

		if crease==1 and what!=1:
			pdb.plug_in_gmic_qt(image, pdb.gimp_image_get_layer_by_name(image, elev), 1, 1,'fx_crease ' + str(amplitude_c)+ "," + str(frequency_c)+ "," + str(boundary))	
			pdb.gimp_item_set_name(image.layers[0], elev+" Crease")	

		#pdb.gimp_layer_set_mode(pdb.gimp_image_get_layer_by_name(image, elev),LAYER_MODE_DIFFERENCE_LEGACY)
	for vector in image.vectors:
		if vector.name=="Planet Ring":
			pdb.gimp_image_remove_vectors(image,pdb.gimp_image_get_vectors_by_name(image,"Planet Ring"))
			
#######################################################################################
	# add for "Preview"														           
	view = pdb.gimp_layer_new_from_visible(image, image, "Preview from Visible")
	pdb.gimp_image_insert_layer(image, view, None, 0)

#######################################################################################	
	
	#pdb.gimp_context_pop()
	#pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
	
hlp=_("\n                      *** Select parameters, then turn on 'Preview' ***\n\n Image -> Precision: must be set to: '8 bit integer' and 'Perceptual gamma (sRGB)'.")	\
+   _("\n\n 		The diameter of the planet (+ Ring) should be smaller\n 			than the shortest side of the image.")	\
+	_("\n\n You must have G'MIC installed (version 3.1.0 or later recommended).")	\
+	_("\n\n  Resizing method 'Preview':\n 1. Disable 'Preview'.\n 2. Drag the corner.\n 3. Turn on the 'Preview' again.")	\
+	_("\n\n Also turn off 'Preview' when You want to change some parameters.")	\
+	_("\n\n This plug-in for existing layers: turns off the visibility")	\
+   _("\n and adds a space before the layer name.")	\
+   _("\n Creates separate layers for the selected options.")	\
+	_("\n You can experiment with their order, visibility, location from center,")	\
+	_("\n mode and opacity.")	\
+	_("\n\n I wish You good use of this plugin, have fun:")	\
+	  "\n\n			   Pocholo & MareroQ."

register(
	"render_planet_and_stars",                           
	_("P&M Cosmos Ver.2.1."),
	_("Creates Planet and Stars"),
	"Pocholo, MareroQ",			        # Author
	"GPL 3", 			                # Copyright
	"2022",				                # Date
	_("Render Planet & Stars..."),      # name
	"RGBA", 
	[
	(PF_IMAGE,   "image", "Input image", None),
	(PF_DRAWABLE,"drawable", "Input layer", None),
	(PF_OPTION,  "create_pl", _("Create Planet? ") , 0 ,[_("DON'T USE"),_("Type Earth"),_("Two Colors"), _("Texture and\nSecond Color"),_("Gas-Planet\n(First Color)"),_("Lava"), _("Alien 1\n(Popcorn)"),_("Alien 2\n(Newton)"),_("Alien 3\n(Complex)"), _("Random\nPlasma"), _("Dirty\n(First Color)"), _("Wrinkled\n(First Color)"),_("Cratered"),_("Simple\n(First Color)"),_("Pointillisme\n(FG-First Color\n BG-Second Color)"),_("Drop Water\n(First Color)"), _("Cloudy\n(with active gradient)"), _("Camouflage")],{'newLine':'0'}),
	(PF_SPINNER, "r_planet", _("   Radius\n   Planet:"), 150, (10, 3000, 1),{'newLine':1}),
	(PF_COLOR,   "color1", _("Two Color:\n   First"), (108,130,58),0,{'newLine':'0'}), 
	(PF_COLOR,   "color2", _("   Two Color:\n     Second"),(78,93,124),0,{'newLine':1}),
	(PF_TOGGLE , "changeColor", _("Change Color?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0'}),		
	(PF_COLOR,   "planColor", _("   Color:"), (94, 150, 255),0,{'newLine':1}),
	(PF_TOGGLE , "useCustomTexture", _("Use Custom\nTexture?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0'}),	
	(PF_PATTERN, "customTexture", _("   Texture:"), "Crack",0,{'newLine':1}),			
	(PF_TOGGLE , "icePole", _("Add Ice Poles?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0'}),
	(PF_SPINNER, "ice_angle", _("  ice angle\n  (deg.):"), 0, (-45, 45, 1),{'newLine':1,}),
	(PF_SPINNER, "ice_thickness", _("  ice thickness:"), 50, (10, 1000, 1),{'newLine':'0'}),		
	(PF_SPINNER, "icePoleop", _("  ice opacity:"), 75, (10, 100, 1),{'newLine':1}),
	(PF_SPINNER, "brightness", _("Brightness:"), 0, (-0.5, 0.5, 0.01),{'newLine':'0'}),
	(PF_SPINNER, "contrast", _("   Contrast:"), 0, (-0.5, 0.5, 0.01),{'newLine':1}),	

	(PF_TOGGLE , "atmosphere", _("Add Luminance?"), 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':1}),
	(PF_COLOR,   "color_atm", _("  color:"), (78,93,124),0,{'newLine':'1','tab':1}),
	(PF_SPINNER, "atmosphere_opacity", _("  opacity:"), 75, (10, 100, 1),{'newLine':'0','tab':1}),	
	(PF_SPINNER, "atmoThickness", _("  thickness:"), 20, (2, 500, 1),{'newLine':1,'tab':1}),
	(PF_TOGGLE , "moon", _("Lunar?"), 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':1}),		
	(PF_TOGGLE , "addClouds", _("Add Clouds\nto Planet?"), 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':1}),
	(PF_COLOR,   "cloud_color", _("  colorize:"), (20,170,200),0,{'newLine':'0','tab':1}),
	(PF_SPINNER, "clouds_opacity", _("  opacity:"), 75, (10, 100, 1),{'newLine':1,'tab':1}),
	(PF_TOGGLE , "lightning", _("Add\nLightning?"), 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':1}),
	(PF_COLOR,   "light", _("  color:"), (180,190,250),0,{'newLine':1,'tab':1}),
	
	(PF_OPTION,  "shadow_phases", _("Add Shadow \nPhase:"), 0, [_("DON'T USE"), _("Crescent Shadow "),_("Quarter Planet Shadow"),_("Waxing Gibbous Shadow")],{'newLine':1,'tab':2}),	
	(PF_SPINNER, "sun_Angle", _("  sun Angle\n  (deg.):"), 45, (-180, 180, 1),{'newLine':1,'tab':2}),			
	(PF_TOGGLE , "run_long_s" , _("Add Long\nShadow?"), 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':2}),		
	(PF_SPINNER, "angle_ls", _("  angle:"), 45, (-180, 180, 1),{'newLine':'0','tab':2}),
	(PF_SPINNER, "length_ls", _("  length:"), 200, (1, 1000, 1),{'newLine':1,'tab':2}),	
	(PF_SPINNER, "midpoint_rel", _("  midpoint:"), 0.8, (0, 1, 0.01),{'newLine':'0','tab':2}),
	(PF_COLOR,   "color_ls", _("  color:"), (0,0,0),0,{'newLine':1,'tab':2}),
	(PF_TOGGLE , "invert_color_ls" , _("Invert\nLong\nShadow") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':2}),
	(PF_SPINNER, "color_ls_opacity", _("  opacity:"), 100, (10, 100, 1),{'newLine':1,'tab':2}),		

	(PF_SPINNER,    "sm_stars", "Small Stars:", 0, (0, 10000, 100),{'newLine':'0','tab':3}),
	(PF_SPINNER,    "mediums", "  Medium Stars:", 0, (0, 1000, 10),{'newLine':1,'tab':3}),
	(PF_SPINNER,    "bigs", "Big Stars:", 0, (0, 200, 1),{'newLine':'0','tab':3}),
	(PF_SPINNER,    "planets", "  Distant Planets:", 0, (0, 100, 1),{'newLine':1,'tab':3}),
	(PF_TOGGLE , "run_stars_gmic" , _("Add\nGmic Stars?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':3}),
	(PF_TOGGLE , "motion_stars_gmic" , _("  Zoom motion?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':3}),	
	(PF_SPINNER, "density", _("  density:"), 150, (1, 200, 1),{'newLine':'0','tab':3}),		
	(PF_SPINNER, "depth", _("  depth:"), 1.5, (0, 5, 0.1),{'newLine':1,'tab':3}),
	(PF_SPINNER, "size", _("  size:"), 8, (8, 128, 1),{'newLine':'0','tab':3}),	
	(PF_SPINNER, "thickness", _("  thickness:"), 0.20, (0.1, 1, 0.01),{'newLine':1,'tab':3}),	
	(PF_SPINNER, "smoothness", _("  smoothness:"), 5, (0, 10, 0.1),{'newLine':'0','tab':3}),	
	(PF_COLOR,   "color_gmic", _("  color:"), (200,200,30),0,{'newLine':1,'tab':3}),
	(PF_TOGGLE , "add_color" , _("Add\nRandom Color?"), 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':3}),	
	(PF_TOGGLE , "add_nebula" , _("  Add\n  Nebula?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':3}),	
	(PF_TOGGLE , "create_brightness" , _("Add\nBrightness?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':3}),
	(PF_TOGGLE , "quasar" , _("  Add Quasar?\n  (color second)") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':3}),		
	(PF_TOGGLE , "add_star_burst" , _("Add Star Burst?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':3}),
	(PF_COLOR,   "color_sb",     _("  color:"), (100,180,180),0,{'newLine':1,'tab':3}),
	
	(PF_TOGGLE , "add_ring" , _("Add Ring?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':4}),
	(PF_TOGGLE , "burn" , _("  Fragment Blur?\n     (vortex)") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':4}),		
	(PF_SPINNER, "dist_r", _("Distance\nfrom Planet:"), 10, (0, 500, 1),{'newLine':'0','tab':4}),
	(PF_SPINNER, "decrese", _("  Percentage\n  Ring Height:"), 70, (10, 100, 10),{'newLine':1,'tab':4}),	 
	(PF_SPINNER, "border_radius", _("Ring Thickness:"), 40, (2, 300, 1),{'newLine':'0','tab':4}),
	(PF_SPINNER, "ring_angle", _("  Ring Angle:"), 20, (-89, 89, 1),{'newLine':1,'tab':4}),		
	(PF_GRADIENT,"gradient", _("Gradient:\n(transparent=black)"), "Golden",0,{'newLine':'0','tab':4}),
	(PF_SPINNER, "noise_spread", _("  Spread Ring:"), 0, (0, 100, 1),{'newLine':1,'tab':4}),

	(PF_TOGGLE , "add_ring" , _("Remove black \ncolor from Ring?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':4}),
	(PF_SPINNER, "ring_angle", _(" Grow black:"), 2, (0, 3, 1),{'newLine':1,'tab':4}),
	
	(PF_TOGGLE , "add_shad_ring" , _("Add Shadow?\n(if Phase exist)") , 0 ,[_("DON'T USE"),_("Automatically\n(=by sun angle)"),],{'newLine':'0','tab':4}),
	(PF_SPINNER, "corect_angle", _("  Change angle:"), 0, (-180, 180, 1),{'newLine':1,'tab':4}),
	(PF_SPINNER, "corect_x", _("Change X size:"), 0, (-500, 500, 1),{'newLine':'0','tab':4}),		
	(PF_SPINNER, "corect_y", _("  Change Y size:"), 0, (-500, 500, 1),{'newLine':1,'tab':4}),
	(PF_TOGGLE , "add_stargate" , _("Stargate\nfrom Ring?\n(don't use shade)") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':4}),
	(PF_TOGGLE , "stargate_motion" , _("  Motion\n  Stargate?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':4}),
		
	(PF_TOGGLE , "super_nova" ,  _("Add Super Nova?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':5}),
	(PF_COLOR,   "color_sn",     _("  color:"), (200,200,30),0,{'newLine':1,'tab':5}),		
	(PF_SPINNER, "center_xs",    _("  center X:"), 0, (0, 1, 0.01),{'newLine':'0','tab':5}),		
	(PF_SPINNER, "center_ys",    _("  center Y:"), 0, (0, 1, 0.01),{'newLine':1,'tab':5}),		
	(PF_SPINNER, "radius_x",     _("  radius:"), 50, (1, 5000, 1),{'newLine':'0','tab':5}),
	(PF_SPINNER, "spokes_count", _("  number\n  of spokes:"), 100, (1, 1000, 1),{'newLine':1,'tab':5}),					
	(PF_TOGGLE , "lens_flare",   _("Add Lens Flare?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':5}),
	(PF_SPINNER, "x_pos",        _("  X-Position:"), 0, (0, 5000, 1),{'newLine':'0','tab':5}),		
	(PF_SPINNER, "y_pos",        _("  Y-Position:"), 0, (0, 5000, 1),{'newLine':1,'tab':5}),
	(PF_TOGGLE , "light_rays",   _("Add Light Rays?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':5}),
	(PF_COLOR,   "color_lr",     _("  color:"), (200,200,30),0,{'newLine':1,'tab':5}),			
	(PF_SPINNER, "density",      _("  density:"), 50, (0, 100, 1),{'newLine':'0','tab':5}),
	(PF_SPINNER, "opacity_lr",   _("  opacity:"), 100, (0, 100, 1),{'newLine':1,'tab':5}),

	(PF_TOGGLE , "chirikov_taylor_map" , _("Add discrete map\nChirikov-Taylor?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':6}),
	(PF_TOGGLE , "spiral_m" , _("  Spiralize?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':6}),
	(PF_TOGGLE , "markus_lyapunov_fractal" , _("Add fractal\nMarkus-Lyapunov?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':6}),	
	(PF_TOGGLE , "spiral_f" , _("  Spiralize?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':6}),
	(PF_OPTION,  "turbulence", _("Turbulence?") , 5 ,[_("Turbulence"),_("Turbulence 2"),_("Fractal Noise"),_("Fractured Clouds"),_("Stardust"),_("DON'T USE")],{'newLine':'0','tab':6}),
	(PF_TOGGLE , "spiral_tur" , _("  Spiralize?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':6}),		
	(PF_TOGGLE , "fractalexplorer" , _("Add Fractal-Explorer\n(interactive)") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':6}),	
	(PF_TOGGLE , "spiral_fe" , _("  Spiralize?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':6}), 				
	(PF_TOGGLE , "flame" , _("Add Flame?\n(interactive)") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':6}),
	(PF_TOGGLE , "spiral" , _("  Spiralize?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':6}),
	(PF_OPTION , "magnetear" , _("Add Magnetar?") , 0 ,[_("DON'T USE"),_("Type\nIncandescent"),_("Type Color\n(First)")],{'newLine':'0','tab':6}),
	(PF_SPINNER, "lines", _("  Lines:"), 5, (1, 10, 1),{'newLine':1,'tab':6}),	

	(PF_OPTION,  "fr_ship", _("FRACTAL Ship?") , 0 ,[_("DON'T USE"),"Popcorn 1","Popcorn 2","Popcorn 3","Popcorn 4","Popcorn 5","Popcorn 6","Popcorn 7","Popcorn 8",_("Custom"), ],{'newLine':'0','tab':7}),
	(PF_SPINNER, "size_ship", _("  % H size:\n  0=no scaling"), 100, (0, 100, 5),{'newLine':1,'tab':7}),
	(PF_STRING,   "preset",  _("G'MIC\nCustom\nCode:"), "fx_rep_pfrac_t_rs 50,1,0.05,3,0.5,45,50,50,0,1,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,0,1,0,0,4,1,0,4,1,0,0,4,1,0,2,1,0,0,4,1,100,0,0,0,0.5,0,0",0,{'newLine':'0','tab':7}),		
	(PF_OPTION,  "beautify", _("  Add Color:") , 0 ,[_("DON'T USE"),_("From Active\nGradient"),_("From Plasma")],{'newLine':1,'tab':7}),	
	(PF_TOGGLE , "polarize" , _("Polar?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':7}),		
	(PF_SPINNER, "angle_f", _("  angle:"), 225, (0, 360, 1),{'newLine':1,'tab':7}),		
	(PF_OPTION,  "ship", _("SPACE Ship?") , 0 ,[_("DON'T USE"),_("Type Torus"),_("Flying Saucer 1"),_("Flying Saucer 2"), _("Gyroid 1"),_("Gyroid 2"), _("Arrowhead"), _("Weird 1"), _("Weird 2"), _("Elipsoid")],{'newLine':'0','tab':7}),	
	(PF_SPINNER, "size_space", _("  % H size:\n  0=no scaling"), 100, (0, 100, 5),{'newLine':1,'tab':7}),
	(PF_OPTION,  "famous_ships" , _("FAMOUS Ship?") , 0 ,[_("DON'T USE"),"Famous Spaceships","Famous Spaceships 2", "Star Navy"],{'newLine':'0','tab':7}),
	(PF_STRING,  "text",  _("  letter::"), "1",0,{'newLine':'1','tab':7}),		
	(PF_SPINNER, "size", _("  size:"), 200, (10, 1000, 1),{'newLine':'0','tab':7}),
	(PF_SPINNER, "angle_fs", "  angle: ", 0, (-360, 360, 1),{'newLine':1,'tab':7}),
	(PF_OPTION,  "pixelize" , _("  surface?") , 0 ,[_("DON'T USE"),_("Super-Pixels"),_("Ministeck"),_("Truchet\n(straight)"),_("Truchet\n(curved)"),_("Grid Triangular"),_("Pills"),_("Box Fitting"),_("Active Pattern\n(scale = % size)")],{'newLine':'0','tab':7}),		
	(PF_SPINNER, "size_pix", _("  scale px"), 10, (10, 100, 1),{'newLine':1,'tab':7}),
	(PF_TOGGLE,  "colorize" , _("Colorify?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':7}),		
	(PF_COLOR,   "color_ship", _("  Color:"), (85,85,127),0,{'newLine':1,'tab':7}),
	(PF_TOGGLE , "neonize" , _("Neonize?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':7}),
	(PF_SPINNER, "radius_neon", _("  radius:"), 5, (2, 25, 0.01),{'newLine':'1','tab':7}),
	(PF_SPINNER, "amount_neon", _("  amount:"), 0.5, (0, 1, 0.01),{'newLine':'0','tab':7}),
	(PF_TOGGLE , "emboss" , _("  Emboss?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'1','tab':7}),	

	(PF_TITLE  , "sel_info"  , _("<b>    The object for the FX effect must first be created:\n  choose the option to create one such item in other tabs.</b>"),(0.0,0.0), None  ,{'iniCol':1,'cols':4,'tab':8}),	
	(PF_TOGGLE , "meteorize" , _("Meteorize\nGmic Stars?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':8}),
	(PF_TOGGLE , "spiralize_met" , _("  Spiralize?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':1,'tab':8}),		
	(PF_SPINNER, "length_m", _("  length"), 50, (1, 300, 1),{'newLine':'0','tab':8}),
	(PF_SPINNER, "angle_m", _("  angle:"), 90, (-180, 180, 1),{'newLine':1,'tab':8}),		
	(PF_TOGGLE , "comet" , _("Create Comet \nfrom Planet?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':8}),
	(PF_SPINNER, "factor_c", _("  braid \n  length (%):"), 50, (20, 100, 5),{'newLine':1,'tab':8}),
	(PF_SPINNER, "angle_t", "  rotate Tail\n  (angle):", -45, (-180, 180, 1),{'tab':8,'newLine':'0'}),
	(PF_SPINNER, "opacity_t", "  opacity Tail:", 100, (0, 100, 1),{'tab':8,'newLine':1}),
	(PF_OPTION,  "explode", _("Choose object\nto explode:") , 0 ,[_("DON'T USE"),_("Planet"),_("Comet Planet"), _("Fractal Ship"),_("Space Ship"), _("Famous Ships")],{'newLine':'0','tab':8}),		
	(PF_TOGGLE , "duplicate" , _("  Keep original\n  object (copy)?") , 1 ,[_("Do Not Copy"),_("YES")],{'newLine':1,'tab':8}),
	(PF_SPINNER, "tile_size", _("  size Piece:"), 40.0, (5, 200, 0.1),{'newLine':'0','tab':8}),		
	(PF_SPINNER, "tile_spacing", _("  distance Piece:"), 20.0, (0.5, 30, 0.1),{'newLine':1,'tab':8}),		
	(PF_COLOR,   "color_in", _("  fire Color IN:"),(230,230, 25) ,0,{'newLine':'0','tab':8}),		
	(PF_COLOR,   "color_out", _("  fire Color OUT:"),(255,60, 20),0,{'newLine':1,'tab':8}),
	(PF_SPINNER, "fire_spred", _("  fire Spred:"), 0.50, (-0.5, 1, 0.01),{'newLine':'0','tab':8}),
	(PF_SPINNER, "object_spred", _("  object Spred:"), 0.10, (-0.5, 1,0.01),{'newLine':1,'tab':8}),
	
	(PF_TITLE  , "elevation_info"  , _("<b>    The object for the FX 3D effect must first be created:\n  choose the option to create one such item in other tabs.</b>"),(0.0,0.0), None  ,{'iniCol':1,'cols':4,'tab':9}),	
	(PF_OPTION , "what" , _("Add an effect to:") , 0 ,[_("DON'T USE"),_("Planet"),_("Comet Planet"),_("Fractal Ship"),_("Space Ships"), _("Famous Ships")],{'newLine':'0','tab':9}),
	(PF_SPINNER, "amplitude_random_deform", _("Random\nDeform:\n(amplitude)"), 0, (0, 100, 1),{'newLine':1,'tab':9}),	
	(PF_TOGGLE , "d_block" , _("3D Block?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':9}),
	(PF_SPINNER, "angle_block", _("  angle:"), 0, (0, 360, 1),{'newLine':1,'tab':9}),  	
	(PF_SPINNER, "resolution", _("  resolution:"), 128, (40, 128, 1),{'newLine':'0','tab':9}),
	(PF_SPINNER, "elevation_b", _("  elevation:"), 2, (-5, 10, 0.1),{'newLine':1,'tab':9}),	
	(PF_TOGGLE , "extrude" , _("3D Extrude?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':9}),
	(PF_SPINNER, "angle_extr", _("  angle:"), 0, (0, 360, 1),{'newLine':1,'tab':9}),
	(PF_TOGGLE , "gradmap" , _("  recolor from\n  active gradient?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':9}),
	(PF_TOGGLE , "alien_map" , _("  use Alien\n  Map?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'1','tab':9}),
	

 	(PF_TOGGLE , "elevation" , _("3D Elevation?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':9}),
	(PF_SPINNER, "angle_elev", _("  angle:"), 0, (0, 360, 1),{'newLine':1,'tab':9}),
	
 	(PF_TOGGLE , "crease" , _("Crease?") , 0 ,[_("DON'T USE"),_("YES")],{'newLine':'0','tab':9}),	
	(PF_OPTION , "boundary" , _("  boundary:") , 3 ,[_("Transparent"),_("Nearest"),_("Periodic"),_("Mirror")],{'newLine':'1','tab':9}),
	(PF_SPINNER, "amplitude_c", _("  amplitude:"), 5, (0, 100, 1),{'newLine':'0','tab':9}),
	(PF_SPINNER, "frequency_c", _("  frequency(%):"), 10, (1, 100, 1),{'newLine':'1','tab':9}),
	
	(PF_TITLE  , "help"  , hlp ,(10,10), None ,{'tab':10}),		
	(PF_TAB    , "ptab"    , "tabs" , 0, (_("Planet"),_("Atmosphere"),_("Shadows"), _("Stars"), _("Ring"),_("Flash"),_("Strange"),_("Ships"),_(" FX "),_("FX-3D"),_("Help")),{'newLine':'1','tab':10} ),		

	],
	[],
	render_planet_and_stars,
	menu="<Image>/Filters/Astronomy/",
	domain = ("P&M Cosmos", locale_directory)
	)

main()

